// ------------------- WIDGET -------------------
var version = "1.6.1";
var isTiger = false; //for Mac OS X Tiger support

//Standard Widget Size:
var s_widget_x = 290;
var s_widget_y = 200;
var widget_x = s_widget_x;
var widget_y = s_widget_y;

var maxInputHeight = 133;

var oldstring = "";
var getlinestring = "";
var lineBreak = "\n";

var hasbeenDeleted = false;
var oldcl = 0;
var powercl = 0;

var isupdate = false;
var s_isupdate = false;

var ClickEnabled = true;

var juststarted = true;
var roundDrag = false;
var fontDrag = false;
var currentlayer = 1;
var intransition = false;
var FLshown = false;

var m_angle = false;
var m_round = false;
var m_restore = false;
var m_fontsize = false;
var inmotion_angle = false;
var inmotion_update = false;
var inresize = false;

faces = new Array("'Helvetica Neue'", "'Lucida Grande'", "Futura", "Georgia", "MarkerFelt-Wide", "'American Typewriter'", "Monaco", "'Courier New'");
fontweights = new Array("bold", "bold", "normal", "normal", "normal", "bold", "normal", "bold");
var s_fontface = 0;
var s_fontsize = 9;
var fontsize = s_fontsize;
var fontface = s_fontface;
var MINFS = 7;
var MAXFS = 18;

results = new Array();

var b_infoButton;
var b_doneButton;
var b_resetButton;
var b_checknowButton;

function say(something)
{
	$('debugger').innerHTML = $('debugger').innerHTML + "<br>" + something;
}

function insertResult(result, spacelessResult, line)
{
	var i=0;
	for(i=results.length-1; i>line; i--)
	{
		var ind = i;
		while(!results[ind] && ind>line)
			ind--;
		
		if(results[ind])
			results[i+1] = new Array(results[ind][0], results[ind][1]);
		else
			results[i+1] = new Array(null, null);
		
		i=ind;
	}

	results[line] = new Array(result, spacelessResult);
}

function delResults()
{
	delete results;
	n_results = 0;
	results = new Array();
	results[0] = new Array();
	results[1] = new Array();
}

function clickline(i)
{
	var c_text = $('calculator').innerText;
	var n_lines = countLines(c_text);

	if(i >= 0 && i <= n_lines)
	{
		oldcl = i;
		powercl = i;
	}
}

function getCurrentLine(c_text)
{
	var lines = c_text.split(lineBreak);
	var lines_old = getlinestring.split(lineBreak);
	
	if(lines.length > 0)
	{
		var i = 0;
		
		for(i = 0; i<lines.length; i++)
		{
			if(lines[i] != lines_old[i])
				return i;
		}
	}
	else
		return -1;

	return -1;
}

function getCurrentTextLine(cl, c_text)
{
	if(c_text.indexOf("\n") >= 0)
	{
		var lines = c_text.split("\n");
		return lines[cl];
	}
	else
		return c_text;
}

function makeHTML(c_text, initAufgabe, cl)
{
	var lines = c_text.split(lineBreak);
	var result = "";
	var i = 0;
	for(i = 0; i<lines.length; i++)
	{
		var sty="normal";
		var end=-1;
		if(i == cl)
		{
			lines[i] = initAufgabe;
		}

		// =
		if(lines[i].substr(0, 1) == "=")
		{
			if(i==cl)
				lines[i] = "= "+Standardize(lines[i].substr(2, lines[i].length-2), 0);
			
			sty="result";
			var al = cl+1;
			var colorindex = i;
			if(i == al)
			{
				sty="cresult";
				colorindex = i;
			}
	
			var start = lines[i].indexOf("=", 0);

			if(start == 0)
			{
				lines[i] = str_insert(start+1, "</span>", lines[i]);
				lines[i] = str_insert(start, "<span class=\""+sty+"\">", lines[i]);
			}
			
			if(results[colorindex])
			{
				var pos0 = lines[i].indexOf(results[colorindex][0], 0);				
				var pos1 = lines[i].indexOf(results[colorindex][1], 0);

				if(pos0 > 0)
				{
					lines[i] = str_insert(pos0+results[colorindex][0].length, "</span>", lines[i]);
					lines[i] = str_insert(pos0, "<span class=\""+sty+"\">", lines[i]);
				}
				else if(pos1 > 0)
				{
					lines[i] = str_insert(pos1+results[colorindex][1].length, "</span>", lines[i]);
					lines[i] = str_insert(pos1, "<span class=\""+sty+"\">", lines[i]);
				}
			}
		}
		else if(lines[i].substr(0, 1) == "#")
		{
			sty="note";
			start = lines[i].indexOf("#", 0);
			if(start == 0)
				lines[i] = str_insert(start, "<span class=\""+sty+"\">", lines[i]);
				
			end = lines[i].length;
			
			if(start == 0)
				lines[i] = str_insert(end, "</span>", lines[i]);
		}
		else if(lines[i].substr(0, 1) == "?")
		{
			sty="error";
			start = lines[i].indexOf("?", 0);
			if(start == 0)
				lines[i] = str_insert(start, "<span class=\""+sty+"\">", lines[i]);
				
			end = lines[i].length;
			
			if(start == 0)
				lines[i] = str_insert(end, "</span>", lines[i]);
		}
		else if(lines[i].substr(0, 4) == "help" || lines[i].substr(0, 4) == "Help" || lines[i].substr(0, 4) == "HELP")
		{
			sty="help";
			lines[i] = str_insert(0, "<span class=\""+sty+"\">", lines[i]);
			end = lines[i].length;
			lines[i] = str_insert(end, "</span>", lines[i]);
		}
		else if(i==cl)
			lines[i] = Standardize(lines[i], 0);
		
		lines[i] = str_replace("<br></span>", "</span><br><br>", lines[i]);
		lines[i] = str_replace("&nbsp;", " ", lines[i]);
		lines[i] = str_replace(spacerHex, " ", lines[i]);
		
		result += "<div id=\"nr" + i + "\" class=\"normal\" onclick=\"clickline("+i+");\">" + lines[i];
		if(sty == "result" || sty == "cresult")
			result += "&nbsp;";
		result += "</div>";
	}
	
	result = str_replace("*%", "%", result);
	result = str_replace("%*", "%", result);
	result = str_replace("*=", "=", result);
	result = str_replace("=*", "=", result);
	result = str_replace("*<", "&lt;", result);
	result = str_replace("<*", "&lt;", result);
	result = str_replace("<", "&lt;", result);
	
	result = str_replace("&lt;/", "</", result);
	result = str_replace("&lt;div", "<div", result);
	result = str_replace("&lt;span", "<span", result);
	result = str_replace("&lt;br", "<br", result);
	return result;
}

function countLines(c_text)
{
	var lines = 1;
	var pos = 0;
	while(c_text.indexOf(lineBreak, pos) >= 0)
	{
		lines++;
		pos = c_text.indexOf(lineBreak, pos) + lineBreak.length;
	}
	
	return lines;	
}

function outputMS(mathstring, c_text, initAufgabe, cl, event)
{
	var n_lines = countLines(c_text);
	var lines = c_text.split(lineBreak);

	var i = 0;
	var result = "";
	for(i = 0; i<lines.length; i++)
	{
		if(i != (cl+1))
			result += lines[i] + "\n";
		else
		{
			result += mathstring + "\n";
			if(cl >= 0)
				oldcl=cl;
		}
	}

	result = makeHTML(result, initAufgabe, cl);
	$("calculator").innerHTML = result;
	
	if(event != 0)
	{
		window.getSelection().setPosition($("nr"+(cl+1)), lines[cl+1].length+10);
		if(cl+5>n_lines)
			focusCalc();
	}

	return 0;
}

function nextLine(cl)
{
	cl++;
	window.getSelection().setPosition($("nr"+cl), $("nr"+cl).innerText.length - 1);
	return 0;
}

function getOldString(event)
{
	if(event.keyCode >= 37 && event.keyCode <= 40)	//Arrow keys
	{
		myScrollArea.refresh();
		return 0;
	}
	else
		checkDivHeight();

	var teststring = $('calculator').innerText;
	var l = getCurrentTextLine(getCurrentLine(teststring), oldstring);
	if(l)
	{
		if(l.substr(-1) != "^" && l.substr(-2, 1) != "^")
			getlinestring = teststring;
		else
			getlinestring = oldstring;
	}
	else
		getlinestring = oldstring;

	oldstring = teststring;
}

function checkDivHeight()
{
	myScrollBar.refresh();
	myScrollArea.refresh();
	$("scrollbar").style.width = "25px";
	return 0;
}

function getMathString(event)
{
	if(event.keyCode >= 37 && event.keyCode <= 40)	//Arrow keys
		return 0;
	
	if(event.keyCode == 27) //ESC key
	{
		wipeBoard();
		return 0;
	}

	var c_text = $('calculator').innerText;
	var cl = getCurrentLine(c_text);
	
	if(cl < 0)
		cl = powercl;

	checkDivHeight();
	getVars();
	getFuncs();

	var initAufgabe = "";

	if(cl >= 0)
	{
		if(event.keyCode == 13)
		{
			var mathstring = getCurrentTextLine(oldcl, oldstring);
			
			if(mathstring)
			{
				if(mathstring.length >= 1)
				{
					if(mathstring.substr(0, 1) == "#")
					{
						var mathstring = getCurrentTextLine(oldcl+1, oldstring);
					}
				}
			}

			if(mathstring != "" && mathstring != undefined)
			{
				if(isAnsOp(mathstring.substr(0, 1)))
					mathstring = str_insert(0, "ans", mathstring);
			}
					
			initAufgabe = mathstring;
			
			if(initAufgabe)
			{
				if(initAufgabe.length >= 4)
				{
					var l=0;
					if(initAufgabe.substr(0, 4) == "help" || initAufgabe.substr(0, 4) == "Help" || initAufgabe.substr(0, 4) == "HELP")
						l = 4;
					if(initAufgabe.substr(0, 5) == "help " || initAufgabe.substr(0, 5) == "Help " || initAufgabe.substr(0, 5) == "HELP ")
						l = 5;
					if(l>3)
					{
						var term = "";
						if(l>4)
							term = initAufgabe.substr(5);
						
						helpSearch(term);
						outputMS("<br>", c_text, initAufgabe, oldcl, event);
						powercl = oldcl+1;
						oldcl = -1;
						checkDivHeight();
						return 0;
					}
				}
			}

			if(mathstring != "" && mathstring != undefined)
			{
				if(mathstring.indexOf("=") == 0)
					mathstring = mathstring.substr(1, mathstring.length-1);
					
				delValues();
				
				doAssign = false;
				var v_name = "";
				var result = "";
				var endresult = "";
				
				mathstring = Standardize(mathstring, 0);

				if((mathstring.indexOf("==")>=0 || mathstring.indexOf("<")>=0 || mathstring.indexOf(">")>=0) && (mathstring.indexOf("?") != 0 && mathstring.indexOf("#") != 0))
				{
					doAssign = true;
					endresult = unequation(mathstring) + "<br>";
				}
				else if(mathstring.indexOf(":") > 0 && (mathstring.indexOf("?") != 0 && mathstring.indexOf("#") != 0))
				{
					v_name = mathstring.substr(0, mathstring.indexOf("="));
					v_name = str_replace(" ", "", v_name);
	
					doAssign = true;
					endresult = assignfunction(mathstring) + "<br>";
				}
				else if(mathstring.indexOf("=") > 0 && (mathstring.indexOf("?") != 0 && mathstring.indexOf("#") != 0))
				{
					v_name = mathstring.substr(0, mathstring.indexOf("="));
					v_name = str_replace(" ", "", v_name);
	
					doAssign = true;
					endresult = assignvar(mathstring) + "<br>";
				}
				
				mathstring = str_replace(" ", "", mathstring);
				mathstring = str_replace("=", "", mathstring);
			
				if(mathstring!="")
				{
					if((mathstring.indexOf("?") != 0) && (mathstring.indexOf("#") != 0))
					{
						if(!doAssign) //notes
						{
							result = solveProblem(mathstring);

							if(result.indexOf("NaN") < 0)
							{								
								var result_spacer = result;
								
								//1 000 000:
								if((result.indexOf("Infinity") < 0) && (result.indexOf("*i") < 0))
								{
									var commapos = result_spacer.indexOf(".")-1;
									if(commapos < 0)
										commapos = result_spacer.indexOf("e")-1;
									if(commapos < 0)
										commapos = result_spacer.length-1;
										
									var i=0;
									for(0; commapos>=0; commapos--)
									{
										if(i > 1)
										{
											if(commapos == 1 && result_spacer.substr(0, 1)=="-")
												break;

											result_spacer = str_insert(commapos, " ", result_spacer);	
											i=-1;
										}
										i++;
									}
								}

								endresult = "= "+result_spacer;
							}
							else
								endresult = "? Error";
						}
						
						var testLine = oldcl;
						if(oldcl == 0) testLine=1;
						var testPrevLine = c_text.split(lineBreak);
						if(str_replace(spacerHex, "", testPrevLine[testLine]) == endresult || testPrevLine[testLine].indexOf("?")==0 || testPrevLine[testLine].indexOf("#")==0)
							return 0;
							
						if(errortext.length > 0)
						{
							endresult = errortext+"<br>";
							errortext = "";
						}

						insertResult(str_replace(" ", "", result), result_spacer, oldcl+1);
						outputMS(endresult, c_text, initAufgabe, oldcl, event);
						powercl = oldcl+1;
						oldcl = -1;
					}
				}
			}
		}
		else
		{
			if(cl != -1)
				oldcl = cl;
		}
	}

	checkDivHeight();
	return 0;
}

function preventClickOnCalc()
{
	ClickEnabled = false;
}

function focusCalc()
{
	if(ClickEnabled)
	{
		var len = $('calculator').innerHTML.length;
		myScrollArea.verticalScrollTo(len);

		window.getSelection().setPosition(calculator, len);
	}
	
	ClickEnabled = true;
}

function b2i(b)
{
	if(b)
		return parseInt(1);
	else
		return parseInt(2);
}

function i2b(i)
{
	if(Math.round(i)==1)
		return true;
	else
		return false;
}

function saveWidgetSize()
{
	inresize = false;
	if(window.widget)
	{
		setGlobalPreferenceForKey(widget_x, createKey("cbwidth"));
		setGlobalPreferenceForKey(widget_y, createKey("cbheight"));
	}
}

function saveWidgetSettings()
{
	if(window.widget)
	{
		setInstancePreferenceForKey(b2i(israd), "angle");
		setInstancePreferenceForKey(r_digits, "round");
		setGlobalPreferenceForKey(fontsize, createKey("fontsize"));
		setGlobalPreferenceForKey(fontface, createKey("fontface"));
		setInstancePreferenceForKey(b2i(isupdate), "update");
	}
}

function saveVar(j)
{
	if(window.widget)
	{
		var i = vars[0].length-1;
		widget.setPreferenceForKey(i, "n_vars");
		
		widget.setPreferenceForKey(vars[0][j], "varname_"+j);
		widget.setPreferenceForKey(vars[1][j], "varval_"+j);
	}
}

function saveFunc(j)
{
	if(window.widget)
	{
		var i = funcs[0].length-1;
		widget.setPreferenceForKey(i, "n_funcs");
		
		widget.setPreferenceForKey(funcs[0][j], "funcname_"+j);
		widget.setPreferenceForKey(funcs[1][j], "funccode_"+j);
		widget.setPreferenceForKey(funcs[2][j], "funcpars_"+j);
	}
}

function saveVars()
{
	if(window.widget)
	{
		var i = vars[0].length-1;
		widget.setPreferenceForKey(i, "n_vars");
		var j = 4;
		for(j=i; j>=4; j--)
		{
			if(widget.preferenceForKey("varval_"+j))
			{
				if(widget.preferenceForKey("varval_"+j) == vars[1][j])
					continue;
				else
				{
					widget.setPreferenceForKey(vars[0][j], "varname_"+j);
					widget.setPreferenceForKey(vars[1][j], "varval_"+j);
				}
			}
		}
	}
}

function getVars()
{
	if(window.widget)
	{
		var i = 0;
		if(widget.preferenceForKey("n_vars"))
			i = parseInt(widget.preferenceForKey("n_vars"));
		
		if(i > 4)
		{
			var j = 4;
			for(j=i; j>=4; j--)
			{
				if(widget.preferenceForKey("varname_"+j))
					vars[0][j] = widget.preferenceForKey("varname_"+j);
				
				if(widget.preferenceForKey("varval_"+j))
					vars[1][j] = widget.preferenceForKey("varval_"+j);
			}
		}
	}
}

function getFuncs()
{
	if(window.widget)
	{
		var i = 0;
		if(widget.preferenceForKey("n_funcs"))
			i = parseInt(widget.preferenceForKey("n_funcs"));
		
		if(i >= 0)
		{
			var j = 0;
			for(j=i; j>=0; j--)
			{
				if(widget.preferenceForKey("funcname_"+j))
					funcs[0][j] = widget.preferenceForKey("funcname_"+j);
				
				if(widget.preferenceForKey("funccode_"+j))
					funcs[1][j] = widget.preferenceForKey("funccode_"+j);

				if(widget.preferenceForKey("funcpars_"+j))
					funcs[2][j] = widget.preferenceForKey("funcpars_"+j);
			}
		}
	}
}

function saveSettings()
{
	saveWidgetSettings();

	var c_text = $("calculator").innerText;
	var lines = c_text.split(lineBreak);
	var line = lines.length-1;
	if(line > 0)
	{
		var news = "";
		if(m_angle)
		{
			if(israd)
				news += "# Rad";
			else
				news += "# Deg";
		}
		
		if(m_round)
		{
			if(m_angle)
				news += ", ";
			else
				news += "# ";
				
			news += "Round: "+r_digits;
		}
		
		if(m_restored)
		{
			if(m_angle || m_round)
				news += ", ";
			else
				news += "# ";
				
			news += "Constants &amp; functions restored";
		}
			
		if(news != "")	
			outputMS(news, c_text, news+"<br>", line, 0);
	}
	
	checkUpdate();
	checkDivHeight();
}

function roundStartDragging()
{
	roundDrag = true;
}

function roundStopDragging()
{
	roundDrag = false;
}

function roundDragging(event)
{
	if(roundDrag)
		setRound(event);
}

function setRound(event)
{
	m_round = true;

	var w_thumb = 19;
	var left_thumb = 125;
	var w_track = 101;
	var padding = 10;
	var s_offset = -5;
	
	var x = event.offsetX-padding;
	var y = event.offsetY;
	
	var w_thumb_half = round_ms(w_thumb/2, 0)
	var moveto = x - w_thumb_half+s_offset;
	if(moveto > (w_track - w_thumb_half))
		moveto = w_track - w_thumb_half;
	if(moveto < -w_thumb_half)
		moveto = -w_thumb_half;
	
	$("roundslider_thumb").style.left = (moveto+left_thumb) + "px";
	
	r_digits = round_ms(ACC*x/w_track, 0)-1;
	if(r_digits > ACC)
		r_digits = ACC;
	else if(r_digits < 0)
		r_digits = 0;

	$("text_roundvalue").innerHTML = r_digits;
}

function setRoundKnob(value)
{
	var w_thumb = 19;
	var left_thumb = 125;
	var w_track = 101;
	var padding = 10;
	var s_offset = 0;
	
	var x = (value * w_track) / ACC;
	
	if(x<=w_track && x>=0)
	{
		var w_thumb_half = round_ms(w_thumb/2, 0)
		var moveto = x - w_thumb_half+s_offset;
		if(moveto > (w_track - w_thumb_half))
			moveto = w_track - w_thumb_half;
		if(moveto < -w_thumb_half)
			moveto = -w_thumb_half;
		
		$("roundslider_thumb").style.left = (moveto+left_thumb) + "px";
	}
	$("text_roundvalue").innerHTML = r_digits;
}




function fontStartDragging()
{
	fontDrag = true;
}

function fontStopDragging()
{
	fontDrag = false;
}

function fontDragging(event)
{
	if(fontDrag)
		setFont(event);
}

function setFont(event)
{
	m_fontsize = true;

	var w_thumb = 19;
	var left_thumb = 155;
	var w_track = 100;
	var padding = 30;
	var s_offset = 0;
	
	var intACC = 100;
	
	var x = event.offsetX-padding;
	var y = event.offsetY;
	
	var w_thumb_half = Math.round(w_thumb/2)
	var moveto = x - w_thumb_half+s_offset;
	if(moveto > (w_track - w_thumb_half))
		moveto = w_track - w_thumb_half;
	if(moveto < -w_thumb_half)
		moveto = -w_thumb_half;
	
	$("fontsize_thumb").style.left = (moveto+left_thumb) + "px";
	
	fontsize = Math.round(intACC*x/w_track)-1;
	if(fontsize > intACC)
		fontsize = intACC;
	else if(fontsize < 0)
		fontsize = 0;
		
	var fsDiff = MAXFS - MINFS;
	fontsize = round_ms(fontsize*fsDiff/100, 1)+MINFS;
	
	if(fontsize > MAXFS)
		fontsize = MAXFS;
	else if(fontsize < MINFS)
		fontsize = MINFS;	

	setFontFace();
	centerFaceExample();
}

function setFontKnob(value)
{
	if(fontsize > MAXFS)
		fontsize = MAXFS;
	else if(fontsize < MINFS)
		fontsize = MINFS;	

	var w_thumb = 19;
	var left_thumb = 155;
	var w_track = 100;
	var padding = 30;
	var s_offset = 0;

	var intACC = 100;
	
	var fsDiff = MAXFS - MINFS;
	var setsize = round_ms(100*(fontsize-MINFS)/fsDiff, 1);

	var x = (setsize * w_track) / intACC;
	
	if(x<=w_track && x>=0)
	{
		var w_thumb_half = Math.round(w_thumb/2)
		var moveto = x - w_thumb_half+s_offset;
		if(moveto > (w_track - w_thumb_half))
			moveto = w_track - w_thumb_half;
		if(moveto < -w_thumb_half)
			moveto = -w_thumb_half;
		
		$("fontsize_thumb").style.left = (moveto+left_thumb) + "px";
	}
	setFontFace();
	centerFaceExample();
}

function getFontFace(nr)
{
	var face = faces[0];
	if(nr > 0 && nr < faces.length)
			face = faces[nr] + ", " + face;
		
	face += ", Helvetica";
	return face;
}

function chooseFont(nr)
{
	if(nr >= 0 && nr < faces.length)
	{
		fontface = nr;
		var i=0;
		for(i=0; i<faces.length; i++)
		{
			$("f"+i).className = "";
			if(i == nr)
				$("f"+i).className = "selected";
		}
	}
	
	setFontFace();
}

function setFontFace()
{
	$("text_fontsizenr").style.fontFamily = getFontFace(fontface);
	$("calculator").style.fontFamily = getFontFace(fontface);
	$("text_fontsizenr").style.fontWeight = fontweights[fontface];
	$("calculator").style.fontWeight = fontweights[fontface];
	$("text_fontsizenr").style.fontSize = fontsize + "pt";
	$("calculator").style.fontSize = fontsize + "pt";
	centerFaceExample();
}

function centerFaceExample()
{
	$("text_fontsizenr").style.top = "-" + Math.round($("text_fontsizenr").offsetHeight/2) + "px";
}

function hideFontList()
{
	releaseButton(0);

	if(!FLshown)
		$("fontlist").style.display = "none";
	else
		FLshown = false;
}

function showFontList()
{
	$("fontlist").style.display = "block";
	FLshown = true;
}

function SetAngle()
{
	if(p4k("angle"))
		israd = i2b(p4k("angle"));
	else
		israd = s_israd;

	if(!inmotion_angle)
	{
		inmotion_angle = true;
		move("angleslider", israd, 0);
	}
}

function SetUpdate()
{
	if(p4k("update"))
		isupdate = i2b(p4k("update"));
	else
		isupdate = s_isupdate;

	if(!inmotion_update)
	{
		inmotion_update = true;
		move("updateslider", !isupdate, 1);
	}
}

function move(elid, isright, kind)
{
	var el = $(elid);
	if(el.style.backgroundPositionX != "")
		from = str_replace("px", "", el.style.backgroundPositionX);
	else
		from = 0;
	
	from=parseInt(from);
	var step = -2;
	if(isright)
		step = 2;

	var newLeft = from + step;
	if(newLeft < 0 || newLeft > 37)
	{
		if(newLeft < 0)
			newLeft = 0;
		else
			newLeft = 37;
			
		switch(kind)
		{
			case(0): inmotion_angle = false; break;
			case(1): inmotion_update = false; break;
		}
	}
	else
		setTimeout("move('"+elid+"', "+isright+", "+kind+")", 3);
	
	el.style.background = "url(Images/Slider.png) no-repeat "+newLeft+"px 0px";
		
	return 0;
}

function ChangeAngle()
{
	if(p4k("angle"))
		israd = i2b(p4k("angle"));
	else
		israd = s_israd;
	
	if(israd)
	{
		israd = false;
	}
	else
	{
		israd = true;
	}
	
	if(window.widget)
		setInstancePreferenceForKey(b2i(israd), "angle");
		
	m_angle = true;

	SetAngle();
}

function ChangeUpdate()
{
	if(p4k("update"))
		isupdate = i2b(p4k("update"));
	else
		isupdate = s_isupdate;
	
	if(isupdate)
	{
		$("updateavailable").style.display = "none";
		isupdate = false;
	}
	else
	{
		isupdate = true;
	}
	
	if(window.widget)
		setInstancePreferenceForKey(b2i(isupdate), "update");

	SetUpdate();
}

function pressButton(nr)
{
	switch(nr)
	{
	case(0): $("ffButton").style.background="url(Images/ButtonListPressed.png) no-repeat"; break;
	}
}

function releaseButton(nr)
{
	switch(nr)
	{
	case(0): $("ffButton").style.background="url(Images/ButtonList.png) no-repeat"; break;
	}
}

function helpSite()
{
	if(window.widget)
		widget.openURL('http://calcboard.tastyorange.net/help/index.php?version='+version);
}

function helpSearch(term)
{
	if(window.widget)
	{
		if(term.length > 0)
			widget.openURL('http://calcboard.tastyorange.net/help/search.php?searchstrg='+term);
		else
			helpSite();
	}
}

function updateSite()
{
	if(window.widget)
		widget.openURL('http://calcboard.tastyorange.net/');
}

function closeupdate(obj)
{
	var new_version = obj.outputString;
	obj.close();
	if(new_version != "" && new_version != undefined)
	{
		if(version != new_version)
		{
			$("newversionButton").innerText = new_version;
			doUpdate_settings();
		}
		else
			doNoupdate_settings();
	}
	else
		doNoupdate_settings();
}

function doUpdate_settings()
{
	$("updateavailable").style.display = "block";
	$("checknowButton").style.display = "none";
	$("newversionButton").style.display = "block";
	$("noupdate").style.display = "none";
}

function doNoupdate_settings()
{
	$("updateavailable").style.display = "none";
	$("checknowButton").style.display = "none";
	$("newversionButton").style.display = "none";
	$("noupdate").style.display = "block";
}

function doCheck()
{
	if(window.widget)
		widget.system("/usr/bin/curl http://calcboard.tastyorange.net/version.php", closeupdate);
	else
		doNoupdate_settings();
}

function checkUpdate()
{
	if(isupdate)
		doCheck();
}

function turnEar(ear, status)
{
	$(ear+"ear").style.background = "url(Images/"+ear+"Ear"+status+".png)";
}

function exportContent()
{
	var now = new Date();
	
	var hour = now.getHours();
	var minute = now.getMinutes();
	hour = ((hour < 10) ? "0" + hour : hour);
	minute = ((minute < 10) ? "0" + minute : minute);
	
	var day = now.getDate();
	day = ((day < 10) ? "0" + day : day);
	
	var month = now.getMonth();
	month++;
	month = ((month < 10) ? "0" + month : month);
	
	var year = now.getFullYear();

	var content = "";

	content += "Calc Board Protocol, "+day+"."+month+"."+year+", "+hour+":"+minute+"\r\r";
	content += $("calculator").innerText;
	content = str_replace(" ", "", content);

	content = str_replace("\r", "\n", content);
	content = str_replace("√", "sqrt", content);
	content = str_replace("π", "pi", content);
	content = str_replace("ä", "ae", content);
	content = str_replace("ö", "oe", content);
	content = str_replace("ü", "ue", content);
	content = str_replace("Ä", "Ae", content);
	content = str_replace("Ö", "Oe", content);
	content = str_replace("Ü", "Ue", content);
	content = str_replace("ß", "sz", content);
	content = str_replace("€", "EUR", content);
	content = str_replace("å", "a", content);
	content = str_replace("Å", "A", content);
	content = str_replace("ç", "c", content);
	content = str_replace("Ç", "C", content);
	content = str_replace("Ø", "O", content);
	content = str_replace("ø", "oe", content);
	content = str_replace("∏", "Pi", content);
	content = str_replace("∑", "Sigma", content);
	content = str_replace("Ω", "Omega", content);
	content = str_replace("", "Apple", content);
	content = str_replace("Í", "I", content);
	content = str_replace("ñ", "n", content);
	content = str_replace("á", "a", content);
	content = str_replace("à", "a", content);
	content = str_replace("â", "a", content);
	content = str_replace("Á", "A", content);
	content = str_replace("À", "A", content);
	content = str_replace("Â", "A", content);	
	content = str_replace("é", "e", content);
	content = str_replace("è", "e", content);
	content = str_replace("ê", "e", content);
	content = str_replace("É", "E", content);
	content = str_replace("È", "E", content);
	content = str_replace("Ê", "E", content);
	content = str_replace("í", "i", content);
	content = str_replace("ì", "i", content);
	content = str_replace("î", "i", content);
	content = str_replace("Í", "I", content);
	content = str_replace("Ì", "I", content);
	content = str_replace("Î", "I", content);
	content = str_replace("ó", "o", content);
	content = str_replace("ò", "o", content);
	content = str_replace("ô", "o", content);
	content = str_replace("Ó", "O", content);
	content = str_replace("Ò", "O", content);
	content = str_replace("Ô", "O", content);
	content = str_replace("ú", "u", content);
	content = str_replace("ù", "u", content);
	content = str_replace("û", "u", content);
	content = str_replace("Ú", "U", content);
	content = str_replace("Ù", "U", content);
	content = str_replace("Û", "U", content);
	content = str_replace("∂", "del", content);
	content = str_replace("Ï", "I", content);
	content = str_replace("Ì", "I", content);
	content = str_replace("Ó", "O", content);
	content = str_replace("∆", "Delta", content);
	content = str_replace("ﬂ", "fl", content);
	content = str_replace("œ", "oe", content);
	content = str_replace("Œ", "Oe", content);
	content = str_replace("æ", "ae", content);
	content = str_replace("Æ", "Ae", content);
	content = str_replace("¥", "Yen", content);
	content = str_replace("Ù", "U", content);
	content = str_replace("∫", "Integral", content);
	content = str_replace("∞", "Infinity", content);
	content = str_replace("&infin;", "Infinity", content);
	content = str_replace("&infin;", "Infinity", content);
	content = str_replace("&rarr;", "->", content);
	content = str_replace("→", "->", content);
	content = str_replace("…", "...", content);
	content = str_replace("÷", "/", content);
	content = str_replace("–", "-", content);
	content = str_replace("—", "-", content);
	content = str_replace("°", "Degree", content);
	
	var kommando = "/bin/echo \""+content+"\" > ~/Desktop/CalcBoard_"+year+"-"+month+"-"+day+"_"+hour+minute+".txt";
	if(window.widget)
	{
		widget.system(kommando, null);
	}
}

function wipeBoard()
{
	preventClickOnCalc();
	delResults();

	oldstring = "";
	lineBreak = "\n";
	errortext = "";
	hasbeenDeleted = false;
	oldcl = 0;
	useOldCl = false;
			
	$("calculator").innerHTML = "";	
	
	myScrollArea.refresh();
	ClickEnabled = true;
	focusCalc();
	return 0;
}

function resetVars()
{
	m_restored = true;
	$("resetButton").style.display = "none";
	$("text_restore_desc").innerText = "Calc Board has been restored.";

	var i=0;
	var j=0;
	for(i=0; i<N_HF; i++)
	{
		for(j=0; j<funcs[0].length; j++)
		{
			if(hf[i] == funcs[0][j])
			{
				funcs[0][j] = null;
				funcs[1][j] = null;
				funcs[2][j] = null;
				saveFunc(j);
			}
		}
		
		for(j=0; j<vars[0].length; j++)
		{
			if(hf[i] == vars[0][j])
			{
				vars[0][j] = null;
				vars[1][j] = null;
				saveVar(j);
			}
		}
	}

	initVars(false);
	saveVars();
}

function load()
{
	if((navigator.appVersion.indexOf("AppleWebKit/4") > 0) || (navigator.appVersion.indexOf("AppleWebKit/3") > 0) || (navigator.appVersion.indexOf("AppleWebKit/2") > 0))
		isTiger = true;
	
	if(isTiger)
	{
		$("calculator").style.letterSpacing = "0px";
		$("widgetface").style.display = "none";
		$("tigerface").style.display = "block";
	}

	delValues();
	
	vars[0][0] = "Ans"; vars[1][0] = 0;
	vars[0][1] = "ans"; vars[1][1] = 0;
	vars[0][2] = "Answer"; vars[1][2] = 0;
	vars[0][3] = "answer"; vars[1][3] = 0;

	initVars(true);
	getVars();
	getFuncs();
	
	var n_vars = vars[0].length;
	var i = 0;
	
	for(i=0; i<n_vars; i++)
	{
		if(vars[0][i])
		{
			if(checkVar(vars[0][i]) != 0)
			{
				vars[0][i] = null;
				vars[1][i] = null;
				saveVar(i);
			}
		}
	}
	
	if(p4k("round"))
		r_digits = p4k("round");
	else
		r_digits = s_digits;
		
	if(r_digits > ACC) r_digits = ACC;
	
	if(p4k("angle"))
		israd = i2b(p4k("angle"));
	else
		israd = s_israd;
		
	if(p4k("fontsize"))
		fontsize = p4k("fontsize");
	else
		fontsize = s_fontsize;
	
	if(p4k("fontface"))
		fontface = p4k("fontface");
	else
		fontface = fontface;
	
	if(p4k("update"))
		isupdate = i2b(p4k("update"));
	
	if(p4k("cbwidth"))
		widget_x = p4k("cbwidth");
		
	if(p4k("cbheight"))
		widget_y = p4k("cbheight");

	checkUpdate();
	
	b_infoButton = new AppleInfoButton($('infoButton'), $('front'), "white", "white", null);
	b_doneButton = new AppleGlassButton($('doneButton'), "Done", showfrontside);
	b_resetButton = new AppleGlassButton($('resetButton'), "Restore Standards", resetVars);
	b_checknowButton = new AppleGlassButton($('checknowButton'), "Now", doCheck);
	myScrollBar = new AppleVerticalScrollbar($("scrollbar"));
	myScrollArea = new AppleScrollArea($("calculator"));
	myScrollArea.addScrollbar(myScrollBar);
	
	resizeBoard(widget_x, widget_y);
	
	SetAngle();
	SetUpdate();
	setRoundKnob(r_digits);
	setFontKnob(fontsize);
	chooseFont(fontface);
	
	if(window.widget)
		widget.onremove = wipePrefs;
}

function wipePrefs()
{
	setInstancePreferenceForKey(null, "round");	
	setInstancePreferenceForKey(null, "angle");
	setInstancePreferenceForKey(null, "update");
	setInstancePreferenceForKey(null, "fontsize");
	setInstancePreferenceForKey(null, "cbwidth");
	setInstancePreferenceForKey(null, "cbheight");
}

function $(id)
{
	return document.getElementById(id);
}

function createKey(key)
{
	if(window.widget)
		key = widget.identifier + "-" + key;

	return key;
}

function setInstancePreferenceForKey(value, key)
{
	setGlobalPreferenceForKey(value, createKey(key));
	
	if(value != null)
		setGlobalPreferenceForKey(value, key);
}

function setGlobalPreferenceForKey(value, key)
{
	if(window.widget)
		widget.setPreferenceForKey(value, key);
}

function p4k(key)
{
	var result = false;
	if(window.widget)
	{
		if(widget.preferenceForKey(key))
			result = widget.preferenceForKey(key);
			
		if(widget.preferenceForKey(createKey(key)))
			result = widget.preferenceForKey(createKey(key));
	}

	return result;
}

function killDockTexts()
{
	$("text_settings").style.display='none';
	$("text_wipe").style.display='none';
	$("text_help").style.display='none';
}

function showbackside(event)
{
	m_angle = false;
	m_round = false;
	m_restored = false;
	m_fontsize = false;

	$("text_restore_desc").innerText = "";
	$("resetButton").style.display = "block";
	$("checknowButton").style.display = "block";
	$("newversionButton").style.display = "none";
	$("noupdate").style.display = "none";

	var front = $("front");
	var back = $("back");
	
	if(window.widget)
		widget.prepareForTransition("ToBack");
	
	front.style.display="none";
	back.style.display="block";
	
	if(window.widget)		
		setTimeout ('widget.performTransition();', 0);
}

function showfrontside(event)
{
	var front = $("front");
	var back = $("back");
	
	if(window.widget)
		widget.prepareForTransition("ToFront");
	
	front.style.display="block";
	back.style.display="none";
	
	myScrollArea.verticalScrollTo(500000);
	
	if(window.widget)
		setTimeout ('widget.performTransition();', 0);
		
	resizeBoard(widget_x, widget_y);
}

function flipadv(nr)
{
	if(!intransition)
	{
		intransition = true;
		if(nr != currentlayer)
		{
			var n = 4;

			if(nr == 0)
			{
				nr = currentlayer+1;
				if(nr>n)
					nr=1;
			}
			
			if(nr == -1)
			{
				nr = currentlayer-1;
				if(nr<1)
					nr=n;
			}
		
			$("settings1").style.display="block";
			$("settings2").style.display="block";
			$("settings3").style.display="block";
			$("settings4").style.display="block";
			centerFaceExample();
	
			var i = 0;
			for(i=1; i<=n; i++)
			{
				$("optionswitch"+i).innerHTML = "&#x25E6;";
				$("optionswitch"+i).className = "";
			}

			$("optionswitch"+nr).innerHTML = "&#x25CF;";
			$("optionswitch"+nr).className = "chosen";
				
			doTransform(0, nr);
		}
		else
			intransition = false;
	}
}

function doTransform(opac, tolayer)
{
	var s1 = $("settings"+currentlayer);
	var s2 = $("settings"+tolayer);

	opac += 0.1;
	var opp = 1-opac;

	s1.style.opacity=opp;
	s2.style.opacity=opac;
	
	if(opac >= 1)
		finishTransition(tolayer);
	else
		setTimeout("doTransform("+opac+", "+tolayer+")", 20);
}

function finishTransition(nr)
{
	if(nr!=1)
		$("settings1").style.display="none";
	if(nr!=2)
		$("settings2").style.display="none";
	if(nr!=3)
		$("settings3").style.display="none";
	if(nr!=4)
		$("settings4").style.display="none";
		
	currentlayer = nr;
	intransition = false;
}

var growboxInset;
function mouseDown(event)
{
	document.addEventListener("mousemove", mouseMove, true);
	document.addEventListener("mouseup", mouseUp, true);
	growboxInset = {x:(window.innerWidth - event.x), y:(window.innerHeight - event.y)};
	event.stopPropagation();
	event.preventDefault();
}

function resizeBoard(x, y)
{
	if(x<290)
		x = 290;
	if(y<200)
		y = 200;
		
	var maxWidth = 700;
	if(x>maxWidth)
		x = maxWidth;
		
	if(window.widget)
		window.resizeTo(x,y);

	var xdiff = x - s_widget_x;
	var ydiff = y - s_widget_y;

	maxInputHeight = 133 + ydiff;

	$("scrollbar").style.left = parseInt(235 + xdiff) + "px";
	$("scrollbar").style.height = parseInt(123 + ydiff) + "px";
	myScrollBar.setSize(parseInt(123 + ydiff));
	$("scrollbar").style.width = "25px";

	$("calculator").style.maxHeight = parseInt(maxInputHeight) + "px";
	$("calculator").style.width = parseInt(203 + xdiff) + "px";

	$("calcarea").style.width = parseInt(220 + xdiff) + "px";
	$("calcarea").style.height = parseInt(153 + ydiff) + "px";

	$("resize").style.left = parseInt(260 + xdiff) + "px";
	$("resize").style.top = parseInt(160 + ydiff) + "px";
	$("resize_pic").style.left = parseInt(260 + xdiff) + "px";
	$("resize_pic").style.top = parseInt(160 + ydiff) + "px";

	$("updateavailable").style.left = parseInt(194 + xdiff) + "px";

	$("infoButton").style.top = parseInt(127 + ydiff) + "px";
	$("text_wipe").style.top = parseInt(140 + ydiff) + "px";
	$("text_export").style.top = parseInt(140 + ydiff) + "px";
	$("text_help").style.top = parseInt(136 + ydiff) + "px";
	$("text_settings").style.top = parseInt(136 + ydiff) + "px";
	$("sponge").style.top = parseInt(160 + ydiff) + "px";
	$("export").style.top = parseInt(160 + ydiff) + "px";
	$("book").style.top = parseInt(160 + ydiff) + "px";
	$("triangle1").style.top = parseInt(155 + ydiff) + "px";
	
	var x_mid = Math.round(x/2);
	var y_mid = Math.round(y/2);
	
	var xmid = x_mid - 145;
	
	$("infoButton").style.left = parseInt(5 + xmid) + "px";
	$("text_wipe").style.left = parseInt(22 + xmid) + "px";
	$("text_export").style.left = parseInt(38 + xmid) + "px";
	$("text_help").style.left = parseInt(190 + xmid) + "px";
	$("text_settings").style.left = parseInt(220 + xmid) + "px";
	$("sponge").style.left = parseInt(18 + xmid) + "px";
	$("export").style.left = parseInt(64 + xmid) + "px";
	$("book").style.left = parseInt(189 + xmid) + "px";
	$("triangle1").style.left = parseInt(232 + xmid) + "px";
	
	xmid = x_mid - 145;
	var ymid = y_mid - 100;
	
	$("back").style.left = parseInt(xmid) + "px";
	$("back").style.top = parseInt(ymid) + "px";
	
	$("front").style.width = parseInt(284 + xdiff) + "px";
	$("front").style.height = parseInt(190 + ydiff) + "px";
	$("back").style.width = "238px";
	$("back").style.height = "146px";
	
	if(isTiger)
	{
		$("boardimg").style.height = parseInt(137 + ydiff) + "px";
		$("boardimg").style.width = parseInt(246 + xdiff) + "px";
		
		$("upper_center").style.width = parseInt(246 + xdiff) + "px";
		$("upper_right").style.left = parseInt(258 + xdiff) + "px";

		$("middle_left").style.height = parseInt(142 + ydiff) + "px";
		$("middle_center").style.width = parseInt(246 + xdiff) + "px";
		$("middle_center").style.height = parseInt(142 + ydiff) + "px";
		$("middle_right").style.height = parseInt(142 + ydiff) + "px";
		$("middle_right").style.left = parseInt(258 + xdiff) + "px";
		
		$("lower_left").style.top = parseInt(152 + ydiff) + "px";
		$("lower_center").style.top = parseInt(152 + ydiff) + "px";
		$("lower_right").style.top = parseInt(152 + ydiff) + "px";
				
		$("lower_center").style.width = parseInt(246 + xdiff) + "px";
		$("lower_right").style.left = parseInt(258 + xdiff) + "px";
	}
	else
	{
		$("draengler").style.width = parseInt(236 + xdiff) + "px";
		$("draengler").style.height = parseInt(134 + ydiff) + "px";
		
		$("fadeTop").style.width = parseInt(246 + xdiff) + "px";
	}

	myScrollBar.refresh();
	myScrollArea.refresh();
}

function mouseMove(event)
{
	widget_x = event.x + growboxInset.x;
	widget_y = event.y + growboxInset.y;

	resizeBoard(widget_x, widget_y);
	
	if(!inresize)
	{
		setTimeout("saveWidgetSize()", 2000);
		inresize = true;
	}

	event.stopPropagation();
	event.preventDefault();
}

function mouseUp(event)
{
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true);
	event.stopPropagation();
	event.preventDefault();
}


// ------------------- PARSER -------------------

var errortext = "";

var r_digits = 6;
var s_digits = 6;

var israd = true;
var s_israd = true;

var spacerHex = "\u00A0";

var addPi = false;
var addDeg = false;

var doAssign = false;

hf = new Array("√", "ceil", "floor", "random", "round", "abs", "arsinhyp", "arsinh", "arcoshyp", "arcosh", "artanhyp", "artanh", "arcothyp", "arcoth", "arcosechyp", "arcosech", "arcschyp", "arcsch", "arsechyp", "arsech", "asinhyp", "asinh", "acoshyp", "acosh", "atanhyp", "atanh", "acothyp", "acoth", "acosechyp", "acosech", "acschyp", "acsch", "asechyp", "asech", "sinhyp", "sinh", "coshyp", "cosh", "tanhyp", "tanh", "cothyp", "coth", "cosechyp", "cosech", "cschyp", "csch", "sechyp", "sech", "acot", "arccot", "acosec", "arccosec", "acsc", "arccsc", "asec", "arcsec", "acos", "arccos", "asin", "arcsin", "atan", "arctan", "cot", "cosec", "sec", "csc", "sin", "cos", "tan", "exp", "ln", "log", "lg", "ld", "sqrt", "radpi", "rad", "deg", "arg", "rt", "conj", "lk", "gammaf", "gamma", "delta", "kronecker", "levi", "sign", "min", "max", "avg", "mean", "bincof", "comb", "nk", "perm", "vari", "binomial", "mod", "modulo", "trunc", "frac", "H", "heavi");
var N_HF = hf.length;

digits = new Array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9");
var N_DIGITS = digits.length;

digits_point = new Array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ".");
var N_DIGITS_POINT = digits_point.length;

digits_point_e = new Array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ".", "e");
var N_DIGITS_POINT_E = digits_point_e.length;

novar = new Array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ".", "(", ")", "-", "+", "-", "*", "/", ":", ";", "^", "=", ">", "<", "!");
var N_NOVAR = novar.length;

//Not to be found in variable&function names:
novarname = new Array("+", "-", "*", "/", ":", "^", "(", ")", "=", ">", "<", ";", "!", "[", "]");
var N_NOVARNAME = novarname.length;

ops = new Array("+", "-", "*", "/", ":", "^", ".", ",", ")", "=", ">", "<", ";", "!");
var N_OPS = ops.length;

mops = new Array("+", "-", "*", "/", ":", "^", "(", ")", "=", ">", "<", ";", "!");
var N_MOPS = mops.length;

ansops = new Array("+", "*", "/", "^", ">", "<", "!");
var N_ANSOPS = ansops.length;

//ignore +-*/^ in solve() if preceded by:
sops = new Array ("+", "-", "*", "/", ":", "^", "e", "=", ">", "<", ";");
N_SOPS = sops.length;

vars = new Array();
vars[0] = new Array(); //Name
vars[1] = new Array(); //Value

funcs = new Array();
funcs[0] = new Array(); //Name
funcs[1] = new Array(); //Code
funcs[2] = new Array(); //Params

values = new Array();
var v0 = 0;
var v1 = 1;
var v2 = 2;
var vi = 3;
var vpi= 4;
var v180=5;

var ACC=15;
var efunc_counter = 0;

function str_insert(pos, s1, mathstring)
{
	return mathstring.substring(0, pos) + s1 + mathstring.substring(pos);
}

function str_overwrite(from, to, mathstring, newtxt)
{
	return mathstring.substring(0, from) + newtxt + mathstring.substring(to);
}

function str_replace(s1, s2, mathstring)
{
	if(mathstring != "")
	{
		var pos = 0;
		while(mathstring.indexOf(s1, pos) >= 0)
		{
			pos = mathstring.indexOf(s1, pos);
			mathstring = str_overwrite(pos, pos+s1.length, mathstring, s2);
			
			pos+=s2.length;
		}
	}
	
	return mathstring;
}

function initVars(doAns)
{
	if(doAns)
	{
		vars[0][0] = "Ans"; vars[1][0] = 0;
		vars[0][1] = "ans"; vars[1][1] = 0;
		vars[0][2] = "Answer"; vars[1][2] = 0;
		vars[0][3] = "answer"; vars[1][3] = 0;
	}
	
	vars[0][4] = "pi"; vars[1][4] = Math.PI;
	vars[0][5] = "Pi"; vars[1][5] = Math.PI;
	vars[0][6] = "PI"; vars[1][6] = Math.PI;
	vars[0][7] = "pI"; vars[1][7] = Math.PI;
	vars[0][8] = "π"; vars[1][8] = Math.PI;
	vars[0][9] = "E"; vars[1][9] = Math.E;
	vars[0][62] = "Euler"; vars[1][62] = Math.E;
	
	vars[0][10] = "Y"; vars[1][10] = 1e24;
	vars[0][11] = "Z"; vars[1][11] = 1e21;
	vars[0][12] = "Exa"; vars[1][12] = 1e18;
	vars[0][13] = "P"; vars[1][13] = 1e15;
	vars[0][14] = "T"; vars[1][14] = 1e12;
	vars[0][15] = "Giga"; vars[1][15] = 1e9;
	vars[0][16] = "M"; vars[1][16] = 1e6;
	vars[0][17] = "k"; vars[1][17] = 1e3;
	vars[0][18] = "hecto"; vars[1][18] = 1e2;
	vars[0][19] = "d"; vars[1][19] = 1e-1;
	vars[0][20] = "centi"; vars[1][20] = 1e-2;
	vars[0][21] = "m"; vars[1][21] = 1e-3;
	vars[0][22] = "micro"; vars[1][22] = 1e-6;
	vars[0][23] = "n"; vars[1][23] = 1e-9;
	vars[0][24] = "p"; vars[1][24] = 1e-12;
	vars[0][25] = "f"; vars[1][25] = 1e-15;
	vars[0][26] = "a"; vars[1][26] = 1e-18;
	vars[0][27] = "z"; vars[1][27] = 1e-21;
	vars[0][28] = "y"; vars[1][28] = 1e-24;
	
	vars[0][29] = "u"; vars[1][29] = 1.660538782e-27;	//Atommasse (kg)
	vars[0][30] = "Na"; vars[1][30] = 6.02214179e23;	//Avogadro (1/mol)
	vars[0][31] = "mB"; vars[1][31] = 9.27400915e-24;	//Bohr-Magneton (J/T)
	vars[0][32] = "a0"; vars[1][32] = 0.52917720859e-10;	//Bohr-Radius (m)
	vars[0][33] = "kB"; vars[1][33] = 1.3806504e-23;		//Boltzmann (J/K)
	vars[0][34] = "Ce"; vars[1][34] = 2.4263102175e-12;	//Compton-Wellenlaenge Elektron (m)
	vars[0][35] = "Cn"; vars[1][35] = 1.3195908951e-15;	//Compton-Wellenlaenge Neutron (m) ---- CODATA bis hierher
	vars[0][36] = "hp"; vars[1][36] = 1.05457168e-34;	//Drehimpulsquantum (Js)
	vars[0][37] = "%"; vars[1][37] = 0.01;
	vars[0][38] = "el"; vars[1][38] = 1.60217653e-19;	//Elementarladung (C)
	vars[0][39] = "eps"; vars[1][39] = 8.854187817e-12;	//Elektrische Feldkonstante (F/m)
	vars[0][40] = "re"; vars[1][40] = 2.817940325e-15;	//Elektronenradius (m)
	vars[0][41] = "F"; vars[1][41] = 96485.3383;		//Faraday-Konstante (C/mol)
	vars[0][42] = "fine"; vars[1][42] = 7.297352568e-3;	//Feinstrukturkonstante ()
	vars[0][43] = "flux"; vars[1][43] = 2.06783372e-15;	//Flussquant (Wb)
	vars[0][44] = "ge"; vars[1][44] = 2.0023193043718;	//g-Faktor Elektron ()
	vars[0][45] = "R"; vars[1][45] = 8.314472;			//universelle Gaskonstante (J/(mol*K))
	vars[0][46] = "G"; vars[1][46] = 6.67428e-11;		//Gravitationskonstante (m^3/(kg*s))
	vars[0][47] = "gyro"; vars[1][47] = 2.67522205e8;	//Gyromagnetisches Verhaeltnis Proton (rad/(s*T))
	vars[0][48] = "Kj"; vars[1][48] = 483.597879e12;	//Josephson-Konstante (Hz/V)
	vars[0][49] = "mN"; vars[1][49] = 5.05078343e-27;	//Kernmagneton (J/T)
	vars[0][50] = "c"; vars[1][50] = 299792458;			//Vakuumlichtgeschwindigkeit (m/s)
	vars[0][51] = "n0"; vars[1][51] = 2.6867773e25;		//Loschmidt-Konstante (m^-3)
	vars[0][52] = "m0"; vars[1][52] = 12.566370614e-7;	//Magnetische Feldkonstante (N/A^2)
	vars[0][53] = "Vm"; vars[1][53] = 22.413996;	//Molares Gasvolumen (m^3/mol)
	vars[0][54] = "g"; vars[1][54] = 9.80665;			//Normalfallbeschleunigung (m/s^2)
	vars[0][55] = "h"; vars[1][55] = 6.6260693e-34;		//Plancksches Wirkungsquantum (Js)
	vars[0][56] = "Rk"; vars[1][56] = 25.812807449e3;	//Quanten-Hall-Widerstand (V/A=Ohm)
	vars[0][57] = "Rf"; vars[1][57] = 3.289841960360e15;//Rydberg-Frequenz (Hz)
	vars[0][58] = "ryd"; vars[1][58] = 1.0973731568525e7;	//Rydberg-Konstante (1/m)
	vars[0][59] = "p0"; vars[1][59] = 101325;			//Normalluftdruck (Pa)
	vars[0][60] = "sb"; vars[1][60] = 5.6704e-8;		//Stefan-Boltzmann (W/(m^2*K^-4))
	vars[0][61] = "b"; vars[1][61] = 2.8977685e-3;	//Wien-Konstante (m*K)
	vars[0][63] = "Ry"; vars[1][63] = 13.6056923;		//Rydberg-Energie (eV)
	vars[0][64] = "Cp"; vars[1][64] = 1.3214098555e-15;	//Compton-Wellenlaenge Proton (m)
	vars[0][65] = "me"; vars[1][65] = 9.10938215e-31;	//Elektronenmasse (kg)
	vars[0][66] = "mp"; vars[1][66] = 1.672621637e-27;	//Protonenmasse (kg)
	vars[0][67] = "mn"; vars[1][67] = 1.674927211e-27;	//Neutronenmasse (kg)
	vars[0][68] = "md"; vars[1][68] = 3.34358320e-27;	//Ruhemasse Deuteron (kg)
	vars[0][69] = "mH"; vars[1][69] = 1.6735340e-27;	//Ruhemasse Wasserstoff (kg)
	vars[0][70] = "ma"; vars[1][70] = 6.6446562e-27;	//Ruhemasse Alpha (kg)
	vars[0][71] = "mm"; vars[1][71] = 1.8835313e-28;	//Ruhemasse Myon (kg)
	vars[0][72] = "mt"; vars[1][72] = 3.16777e-27;	//Ruhemasse Tau-Lepton (kg)
}

function addValueC(re, im)
{
	values[values.length] = new Array();
	var i = values.length-1;
	
	values[i][0] = re;
	values[i][1] = im;
	
	return i;
}

function addValue(re, im)
{
	if(im == 0)
	{
		switch(re)
		{
		case(0): return v0; break;
		case(1): return v1; break;
		case(2): return v2; break;
		case(180): return v180; break;
		case(Math.PI): return vpi; break;
		}
	}
	else if(re==0 && im==1)
		return vi;

	return addValueC(re, im);
}

function delValues()
{
	delete values;
	values=new Array();
	
	v0 = addValueC(0, 0);
	v1 = addValueC(1, 0);
	v2 = addValueC(2, 0);
	vi = addValueC(0, 1);
	vpi= addValueC(Math.PI, 0);
	v180=addValueC(180, 0);
}

function Re(i)
{
	i = parseInt(i);

	if(i<0)
	{
		if(values[-i])
			return -values[-i][0];
		else
			return 1;
	}
	else
	{
		if(values[i])
			return values[i][0];
		else
			return 1;
	}
}

function Im(i)
{
	i = parseInt(i);
	if(i<0)
	{
		if(values[-i])
			return -values[-i][1];
		else
			return 0;
	}
	else
	{
		if(values[i])
			return values[i][1];
		else
			return 0;
	}
}

function checkVar(name)
{
	var j;
	for(j=0; j<N_NOVARNAME; j++)
	{
		if(name.indexOf(novarname[j]) >= 0)
			return novarname[j];
	}
	
	return 0;
}

function isDigit(s)
{
	var j;
	for(j=0; j<N_DIGITS; j++)
	{
		if(s.substr(0, 1) == digits[j])
			return true;
	}
	
	return false;
}

function isDigitOrPoint(s)
{
	var j;
	for(j=0; j<N_DIGITS_POINT; j++)
	{
		if(s.substr(0, 1) == digits_point[j])
			return true;
	}
	
	return false;
}

function isDigitOrPointOrE(s)
{
	var j;
	for(j=0; j<N_DIGITS_POINT_E; j++)
	{
		if(s.substr(0, 1) == digits_point_e[j])
			return true;
	}
	
	return false;
}

function isNoVar(s)
{
	var j;
	for(j=0; j<N_NOVAR; j++)
	{
		if(s.substr(0, 1) == novar[j])
			return true;
	}
	
	return false;
}

function isOp(s)
{
	var j;
	for(j=0; j<N_OPS; j++)
	{
		if(s.substr(0, 1) == ops[j])
			return true;
	}
	
	return false;
}

function isMop(s)
{
	var j;
	for(j=0; j<N_MOPS; j++)
	{
		if(s.substr(0, 1) == mops[j])
			return true;
	}
	
	return false;
}

function isSop(s)
{
	var j;
	for(j=0; j<N_SOPS; j++)
	{
		if(s.substr(0, 1) == sops[j])
			return true;
	}
	
	return false;
}

function isAnsOp(s)
{
	var j;
	for(j=0; j<N_ANSOPS; j++)
	{
		if(s.substr(0, 1) == ansops[j])
			return true;
	}
	
	return false;
}

function double2string(a)
{
	return a.toString();
}

function string2double(a)
{
	return parseFloat(a);
}

function makeComplex(a)
{
	if(a.indexOf("i") >= 0)
		return addValue(0, string2double(a.replace("i", "1")));
	else
		return addValue(string2double(a), 0);
}

function add(s1, s2)
{
	return addValue(Re(s1) + Re(s2), Im(s1) + Im(s2));
}

function subtract(s1, s2)
{
	return addValue(Re(s1) - Re(s2), Im(s1) - Im(s2));
}

function multiply(s1, s2)
{
	return addValue(Re(s1)*Re(s2) - Im(s1)*Im(s2), Re(s1)*Im(s2) + Im(s1)*Re(s2));
}

function divide(s1, s2)
{
	var bottom = Re(s2)*Re(s2)+Im(s2)*Im(s2);
	
	if(bottom == 0)
	{
		errortext="? Division by zero: "+resolveComplex_internally(s1)+"/"+resolveComplex_internally(s2)+"&rarr;"; if(string2double(resolveComplex_internally(s1))<0) errortext += "-&infin;"; else errortext += "&infin;";
		
		return 1;
	}
		
	return addValue((Re(s1)*Re(s2)+Im(s1)*Im(s2))/bottom, (Im(s1)*Re(s2)-Re(s1)*Im(s2))/bottom);
}

function FindOtherBracket(mathstring, position, step, opening, closing)
{
	var depth = step;
	var i = 0;
	for(i=position+step; (i<mathstring.length)&&(i>0); i+=step)
	{
		if(mathstring.substr(i, 1) == opening)
			depth++;
		else if(mathstring.substr(i, 1) == closing)
			depth--;

		if(depth == 0)
			break;
	}
	return i;
}

function EliminateDoubles(mathstring)
{
	while((mathstring.indexOf("--", 0) != -1) ||
		  (mathstring.indexOf("++", 0) != -1) ||
		  (mathstring.indexOf("**", 0) != -1) ||
		  (mathstring.indexOf("//", 0) != -1) ||
		  (mathstring.indexOf("^^", 0) != -1) ||
		  (mathstring.indexOf("-+", 0) != -1) ||
		  (mathstring.indexOf("+-", 0) != -1) ||
		  (mathstring.indexOf("+*", 0) != -1) ||
		  (mathstring.indexOf("-*", 0) != -1) ||
		  (mathstring.indexOf("/*", 0) != -1) ||
		  (mathstring.indexOf("^*", 0) != -1) ||
		  (mathstring.indexOf("*!", 0) != -1))
	{
		mathstring = str_replace("--", "+", mathstring);
		mathstring = str_replace("++", "+", mathstring);
		mathstring = str_replace("**", "*", mathstring);
		mathstring = str_replace("//", "/", mathstring);
		mathstring = str_replace("^^", "^", mathstring);
		mathstring = str_replace("+-", "-", mathstring);
		mathstring = str_replace("-+", "-", mathstring);
		
		mathstring = str_replace("+*", "+", mathstring);
		mathstring = str_replace("-*", "-", mathstring);
		mathstring = str_replace("/*", "/", mathstring);
		mathstring = str_replace("^*", "^", mathstring);
		
		mathstring = str_replace("*!", "!", mathstring);
	}
	return mathstring;
}

function saveFunctionsFromStar(mathstring)
{
	var i=0;
	for(i=0; i<N_HF; i++) //Implemented Functions
	{
		mathstring = str_replace(hf[i]+"*(", hf[i]+"(", mathstring);
	}
	
	var n = funcs[0].length;
	for(i=0; i<n; i++)	//User-defined Functions
	{
		mathstring = str_replace(funcs[0][i]+"*(", funcs[0][i]+"(", mathstring);
	}
	
	if(mathstring.substr(0, 1) == "*")
		mathstring = mathstring.substr(1, mathstring.length);
		
	if(mathstring.substr(mathstring.length-1, 1) == "*")
		mathstring = mathstring.substr(0, mathstring.length-1);
		
	mathstring = str_replace(":*", ":", mathstring);
	if(mathstring.substr(0, 2) == "*(")
		mathstring = mathstring.substr(1);
	
	return mathstring;
}

function Standardize(mathstring, slevel)
{
	if(slevel == 0)
	{
		mathstring = str_replace(" ", "", mathstring);
		mathstring = str_replace(spacerHex, "", mathstring);
		mathstring = str_replace(",", ".", mathstring);
		mathstring = str_replace("[", "(", mathstring);
		mathstring = str_replace("]", ")", mathstring);
		mathstring = str_replace("{", "(", mathstring);
		mathstring = str_replace("}", ")", mathstring);
		mathstring = str_replace(":=", "=", mathstring);
	}
	
	mathstring = str_replace("(", "*(", mathstring);
	var pos=0;
	while(pos >= 0)
	{
		pos = mathstring.indexOf(")", pos);
		if(pos >= 0)
		{
			if(!isSop(mathstring.substr(pos+1, 1)))
			{
				mathstring = str_overwrite(pos, pos+1, mathstring, ")*");
			}
			
			pos++;
		}
	}
	
	pos=0;
	while(pos >= 0) //Search for exp()
	{
		pos = mathstring.indexOf("exp", pos);
		if(pos >= 0)
		{
			if(isNoVar(mathstring.substr(pos-1, 1)))
			{
				mathstring = str_insert(pos, "*", mathstring);
			}
			
			pos+=2;
		}
	}
	
	mathstring = str_replace("(*", "(", mathstring);
	while(mathstring.indexOf(")*)") >= 0)
		mathstring = str_replace(")*)", "))", mathstring);
	while(mathstring.indexOf("(*(") >= 0)
		mathstring = str_replace("(*(", "((", mathstring);
			
	mathstring = EliminateDoubles(mathstring);
	mathstring = saveFunctionsFromStar(mathstring);
	mathstring = str_replace(")(", ")*(", mathstring);
	mathstring = str_replace("-i", "-1*i", mathstring);
	
	pos=0;
	var doinsert=true;
	for(pos=0; pos<mathstring.length; pos++)
	{
		if(isDigitOrPointOrE(mathstring.substr(pos, 1)))
		{
			if(pos+1 < mathstring.length)
			{
				if(!isDigitOrPointOrE(mathstring.substr(pos+1, 1)) && !isOp(mathstring.substr(pos+1, 1)))
				{
					doinsert = false;
					if(pos+2 < mathstring.length && mathstring.substr(pos+1, 1)=="e")
					{
						if((mathstring.substr(pos+2, 1) != "-") || (mathstring.substr(pos+2, 1) != "+"))
							doinsert = true;
					}
					else
					{
						if(mathstring.substr(pos, 1) != "e")
							doinsert = true;
					}
						
					if(doinsert)
					{
						mathstring = str_insert(pos+1, "*", mathstring);
						pos++;
					}
				}
			}
		}
	}
	
	mathstring = EliminateDoubles(mathstring);
	mathstring = saveFunctionsFromStar(mathstring);
	
	return mathstring;
}

function replaceNumbersById(mathstring)
{
	var buffer = "";
	var toreplace = "";
	var left = -1;
	var right = -1;
	
	var pos = 0;

	var testpos = "";

	for(pos=0; pos<mathstring.length; pos++)
	{
		testpos = mathstring.substr(pos, 1);
		if(isDigitOrPointOrE(testpos) || (((testpos=="-")||(testpos=="+")) && mathstring.substr(pos-1, 1)=="e") || (testpos=="i"))
		{
			if(testpos=="i" || testpos=="e")
			{
				if(pos > 0)
				{
					if(!isNoVar(mathstring.substr(pos-1, 1)))
						continue;
				}
				if(pos+1 < mathstring.length)
				{
					if(!isNoVar(mathstring.substr(pos+1, 1)))
						continue;
				}
			}
			
			if(left == -1)
				left = pos;

			buffer += testpos;
			right = pos+1;
		}
		else if(left > -1)
		{
			toreplace = double2string(makeComplex(buffer));
			
			mathstring = str_overwrite(left, right, mathstring, toreplace);
	
			pos = left + toreplace.length - 1;
			left = -1;
			buffer = "";
		}
	}

	if(left > -1)
		{
			toreplace = double2string(makeComplex(buffer));
			
			mathstring = str_overwrite(left, right, mathstring, toreplace);
	
			pos = left + toreplace.length - 1;
			left = -1;
			buffer = "";
		}

	return mathstring;
}

function deg(st)
{
	return multiply((divide(st, vpi)), v180);
}

function rad(st)
{
	return multiply(divide(st, v180), vpi);
}

function radpi(st)
{
	return divide(st, v180);
}

function ceil(st)
{
	return addValue(Math.ceil(Re(st)), Math.ceil(Im(st)));
}

function floor(st)
{
	return addValue(Math.floor(Re(st)), Math.floor(Im(st)));
}

function random(pars)
{
	if(pars.length > 2)
	{
		errortext = "? random: too many parameters";
		return v1;
	}
	else if(pars[1])
	{
		return addValue((Re(pars[1])-Re(pars[0]))*Math.random() + Re(pars[0]),
						(Im(pars[1])-Im(pars[0]))*Math.random() + Im(pars[0]))
	}
	else if(Re(pars[0]) == 0 && Im(pars[0]) == 0)
		return addValue(Math.random(), 0);
	else
		return addValue(Re(pars[0])*Math.random(), Im(pars[0])*Math.random());
}

function round(st)
{
	return addValue(Math.round(Re(st)), Math.round(Im(st)));
}

function abs(st)
{
	return addValue(Math.sqrt(Re(st)*Re(st) + Im(st)*Im(st)), 0);
}

function arg(st)
{
	var res = argrad(st);
	
	if(!israd)
		res = deg(res);
								
	return res;
}

function argrad(st)
{
	if(Re(st)==0 && Im(st)==0)
	{
		errortext = "? arg(0) not defined";
		return v0;
	}
	
	var res = Math.atan(Im(st) / Re(st));
		
	if(Re(st)<0 && Im(st)>0)
		res += Math.PI;

	if(Re(st)<0 && Im(st)<0)
		res += Math.PI;

	if(Re(st)<0 && Im(st)<0)
		res -= 2*Math.PI;

	if(Re(st) == 0 && Im(st) < 0)
		res = -Math.PI/2

	if(Im(st) == 0)
	{
		if(Re(st) <= 0)
			res += Math.PI;
	}
						
	return addValue(res, 0);
}


function conj(st)
{
	var re = Re(st);
	var im = -Im(st);
		
	return addValue(re, im);
}

function cpow(st, exponent)
{
	if(Im(exponent) == 0)
		return pow(st, string2double(exponent));
	else
		return exp(multiply(exponent, add(addValue(0, Re(argrad(st))), addValue(Re(ln(abs(st))), 0))));
}

function pow(st, n)
{
	if(Im(st) == 0)
	{
		var re = Math.pow(Re(st), Re(n));

		if(Math.abs(re) < 0.000000001*re)
			re = 0;
		
		var res = addValue(re, 0);	
	}
	else
	{
		var r = Re(abs(st));
		var phi = Re(argrad(st));
		n = Re(n);
		var re = Math.pow(r, n)*(Math.cos(n*phi));
		var im = Math.pow(r, n)*(Math.sin(n*phi));
		var res = addValue(re, im);	
		
		var absolute = Re(abs(res));
		
		if(Math.abs(im) < 0.000000001*absolute)
			im = 0;
		if(Math.abs(re) < 0.000000001*absolute)
			re = 0;
		
		res = addValue(re, im);	
	}

	return res;	
}

function real_rt(st, n)
{
	return addValue(Math.pow(Re(st), 1/Re(n)), 0);
}

function rt(st, pars)
{		
	if(pars.length != 3 && pars.length != 2)
	{
		errortext = "? 2 or 3 parameters: rt(x; n; [k])";
		return 1;
	}
	else
	{
		var a = pars[0];
		if(Re(a)==0 && Im(a)==0)
			return v0;

		var k = v0;
		if(pars[2])
			k = pars[2];

		var n = pars[1];

		if(Re(k)>=Re(n))
		{
			errortext = "? Error: k&gt;=n.";
			return 1;
		}
		
		var absolute = Re(real_rt(abs(a), n));
		var phi = Re(argrad(a));
	
		n = Re(n);
		k = Re(k);
		var argu = (phi/n) + k*(2/n)*Math.PI;
		
		var re = absolute*Math.cos(argu);
		var im = absolute*Math.sin(argu);
		absolute = Re(abs(addValue(re, im)));
		
		if(Math.abs(im) < 0.000000001*absolute)
			im = 0;
		if(Math.abs(re) < 0.000000001*absolute)
			re = 0;
		
		return addValue(re, im);
	}
}

function sqrt(st)
{
	var pars = new Array;
	pars[0]=st;
	pars[1]=v2;
	pars[2]=v0;
	
	return rt(st, pars);
}

function exp(st)
{
	var absolute = Math.exp(Re(st));
	var phi = Im(st);
	
	var re = absolute*Math.cos(phi);
	var im = absolute*Math.sin(phi);
	
	if(Math.abs(im) < 0.000000001*absolute)
		im = 0;
	if(Math.abs(re) < 0.000000001*absolute)
		re = 0;
	
	return addValue(re, im);
}

function lk(st, pars)
{
	if(pars.length != 2)
	{
		errortext = "? 2 parameters required: lk(x; k)";
		return 1;
	}
	else
	{
		var k = Re(pars[1]);
		
		if(Re(abs(st)) != 0)
			var re = Math.log(Re(abs(st)));
		else
		{
			var re = 0;
			errortext = "? log(0) &rarr; -&infin;";
		}
		var im = Re(argrad(st)) + 2*k*Math.PI;
	
		return addValue(re, im);
	}
}

function ln(st)
{
	var pars = new Array;
	pars[0] = st;
	pars[1] = v0;

	return lk(st, pars);
}

function log(st, pars)
{
	if(pars.length != 2)
	{
		errortext = "? 2 parameters required: log(x; b)";
		return 1;
	}
	else
	{
		var b = pars[1];
		var p = new Array;
		p[0] = st;
		p[1] = 0;
		var res = divide(lk(st, p), lk(b, p));
		return res;
	}
}

function decreaseAngleByPi(angle)
{
	while(angle > 0)
		angle -= Math.PI;

	while(angle < 0)
		angle += Math.PI;
		
	if(Math.abs(angle) < 1e-7)
		angle = 0;

	return angle;
}

function sin(st)
{
	if(Im(st) != 0)
	{
		var exp1 = multiply(vi, st);
		exp1 = exp(exp1);
		var exp2 = multiply(-vi, st);
		exp2 = exp(exp2);
		var sum = subtract(exp1, exp2);
		var res = divide(sum, addValue(0, 2));
		
		return res;
	}
	else
	{
		var angle = decreaseAngleByPi(Re(st));
		if(angle == 0)
			return v0;
		else
			return addValue(Math.sin(Re(st)), 0);
	}
}

function cos(st)
{
	if(Im(st) != 0)
	{
		var exp1 = multiply(vi, st);
		exp1 = exp(exp1);
		var exp2 = multiply(-vi, st);
		exp2 = exp(exp2);
		var sum = add(exp1, exp2);
		var res = divide(sum, v2);
		
		return res;
	}
	else
	{
		var angle = decreaseAngleByPi(Re(st));
		if(Math.abs(angle) == Math.PI/2)
			return v0;
		else
			return addValue(Math.cos(Re(st)), 0);
	}
}

function tan(st)
{
	if(Im(st) != 0)
	{
		return divide(sin(st), cos(st));;
	}
	else
	{
		var angle = decreaseAngleByPi(Re(st));
		if(Math.abs(angle) == 0)
			return v0;
		else if(Math.abs(angle) == Math.PI/2)
		{
			errortext="? tan("+round_ms(Re(st)/Math.PI, 2)+"&pi;) &rarr; &infin;";
			return 1;
		}
		else
			return addValue(Math.tan(Re(st)), 0);
	}
}

function cot(st)
{
	if(Im(st) != 0)
	{
		return divide(cos(st), sin(st));;
	}
	else
	{
		var angle = decreaseAngleByPi(Re(st));
		if(Math.abs(angle) == Math.PI/2)
			return v0;
		else if(Math.abs(angle) == 0)
		{
			errortext="? cot("+round_ms(Re(st)/Math.PI, 2)+"&pi;) &rarr; &infin;";
			return 1;
		}
		else
			return addValue(1/Math.tan(Re(st)), 0);
	}
}

function asin(st)
{
	if(Im(st) != 0)
	{
		var pars = new Array;
		pars[0] = subtract(v1, pow(st, v2));
		pars[1] = v2;
		pars[2] = v0;
		var inner = add(multiply(vi, st), rt(pars[0], pars));
		var lp = new Array;
		lp[0] = inner;
		lp[1] = v0;
	
		return multiply(-vi, lk(lp[0], lp));
	}
	else
	{
		if(Re(st) > 1)
		{
			errortext = "? Error: asin(x) &forall; -1 &le; x &le; 1";
			return 1;
		}
		
		var res = makeComplex(double2string(Math.asin(Re(st))));
		if(!israd)
			res = deg(res);

		return res;
	}
}

function acos(st)
{
	if(Im(st) != 0)
	{
		var pars = new Array;
		pars[0] = subtract(v1, pow(st, v2));
		pars[1] = v2;
		pars[2] = v0;
		var inner = add(st, multiply(vi, rt(pars[0], pars)));
		var lp = new Array;
		lp[0] = inner;
		lp[1] = v0;
	
		return multiply(-vi, lk(inner, lp));
	}
	else
	{
		if(Re(st) > 1)
		{
			errortext = "? Error: acos(x) &forall; -1 &le; x &le; 1";
			return 1;
		}
		
		var res = makeComplex(double2string(Math.acos(Re(st))));
		if(!israd)
			res = deg(res);

		return res;
	}
}

function atan(st)
{
	if(Im(st) != 0)
	{
		var upper = add(v1, multiply(vi, st));
		var lower = subtract(v1, multiply(vi, st));
		var inner = divide(upper, lower);
		var lp = new Array;
		lp[0] = inner;
		lp[1] = v0;

		return divide(lk(inner, lp), addValue(0, 2));
	}
	else
	{
		var res = makeComplex(double2string(Math.atan(Re(st))));
		if(!israd)
			res = deg(res);

		return res;
	}
}

//ANGLE HYP
function sinh(st)
{
	return multiply(-vi, sin(multiply(vi, st)));
}

function cosh(st)
{
	return cos(multiply(vi, st));
}

function tanh(st)
{
	var s = sinh(st);
	var c = cosh(st);
	return divide(s, c);
}

function coth(st)
{
	return divide(v1, tanh(st));
}

function sech(st)
{
	return divide(v1, cosh(st));
}

function cosech(st)
{
	return divide(v1, sinh(st));
}

//ARCUS HYP
function asinh(st)
{
	var pars = new Array;
	pars[0] = add(pow(st, v2), v1);
	pars[1] = v2;
	pars[2] = v0;
	
	var inner1 = rt(pars[0], pars);
	var inner2 = add(st, inner1);
	
	var lp = new Array;
	lp[0] = inner2;
	lp[1] = v0;
	
	return lk(lp[0], lp);
}

function acosh(st)
{
	var pars = new Array;
	pars[0] = add(pow(st, v2), -v1);
	pars[1] = v2;
	pars[2] = v0;
	
	var inner1 = rt(pars[0], pars);
	var inner2 = add(st, inner1);
	
	var lp = new Array;
	lp[0] = inner2;
	lp[1] = v0;
	
	return lk(lp[0], lp);
}

function atanh(st)
{
	var inner1 = add(v1, st);
	var inner2 = subtract(v1, st);
	
	var lp = new Array;
	lp[0] = divide(inner1, inner2);
	lp[1] = v0;
	
	return multiply(addValue(0.5, 0), lk(lp[0], lp));
}

function acoth(st)
{
	var inner1 = add(st, v1);
	var inner2 = subtract(st, v1);
	
	var lp = new Array;
	lp[0] = divide(inner1, inner2);
	lp[1] = v0;
	
	return multiply(addValue(0.5, 0), lk(lp[0], lp));
}

function asech(st)
{
	var pars = new Array;
	pars[0] = subtract(divide(v1, st), v1);
	pars[1] = v2;
	pars[2] = v0;
	
	var inner1 = rt(pars[0], pars);
	
	pars[0] = add(divide(v1, st), v1);
	
	var inner2 = rt(pars[0], pars);
	
	var inner = add(multiply(inner1, inner2), divide(v1, st));
	
	var lp = new Array;
	lp[0] = inner;
	lp[1] = v0;
	
	return lk(lp[0], lp);
}

function acosech(st)
{
	var pars = new Array;
	pars[0] = add(divide(v1, pow(st, v2)), v1);
	pars[1] = v2;
	pars[2] = v0;
	
	var inner1 = rt(pars[0], pars);
	var inner = add(inner1, divide(v1, st));
	
	var lp = new Array;
	lp[0] = inner;
	lp[1] = v0;
	
	return lk(lp[0], lp);
}

function gamma(z)
{
	if(Re(z) < 0.5)
	{
		return divide(vpi, multiply(sin(multiply(vpi, z)), gamma(subtract(1, z))));
	}
	else
	{
		var gammaa = Math.sqrt(2*Math.PI);
			gammap = new Array(0.99999999999980993, 676.5203681218851, -1259.1392167224028, 771.32342877765313, -176.61502916214059, 12.507343278686905, -0.13857109526572012, 9.9843695780195716e-6, 1.5056327351493116e-7);

		var sum = addValue(gammap[0], 0);
		z = subtract(z, v1);
		
		var i = 0;
		for(i=1; i<gammap.length; i++)
		{
			sum = add(sum, divide(addValue(gammap[i], 0), add(z, addValue(i, 0))));
		}
		
		var t = add(z, addValue(7.5, 0));
		var res = addValue(gammaa, 0);
		res = multiply(res, cpow(t, add(z, addValue(0.5, 0))));
		res = divide(res, exp(t));
		res = multiply(res, sum);
		
		return res;
	}
}


function delta(numbers)
{
	var i=0;
	if(numbers.length > 1)
	{
		for(i=1; i<numbers.length; i++)
		{
			if((Re(numbers[i-1]) != Re(numbers[i])) || (Im(numbers[i-1]) != Im(numbers[i])))
				return v0;
		}
	}
	
	return v1;
}

function levi(numbers)
{
	var swapped = true;
	var temp = 0;
	var n = numbers.length;
	var perms = 0;
	
	if(numbers.length > 1)
	{
		while(swapped && n>=1)
		{
			swapped = false;
			var i=0;
			for(i=1; i<n; i++)
			{
				if(Re(numbers[i-1]) > Re(numbers[i]))
				{
					temp = numbers[i];
					numbers[i] = numbers[i-1];
					numbers[i-1] = temp;
					
					perms++;
					swapped = true;
				}
			}
			n--;
		}

		for(i=1; i<numbers.length; i++)
		{
			if((Re(numbers[i-1]) == Re(numbers[i])) && (Im(numbers[i-1]) == Im(numbers[i])))
				return v0;
		}
	} 
	else
		return v0;

	var sign = Math.pow(-1, perms);
	if(sign > 0)
		return v1;
	else
		return addValue(-1, 0);
}

function sign(st)
{
	if(Re(abs(st)) > 0)
		return divide(st, abs(st));
	else
		return v0;
}

function heavi(st)
{
	if(Re(st) > 0)
		return v1;
	else
		return v0;
}

function bincof(st, pars)
{
	if(pars.length < 2)
	{
		errortext = "? Need 2 parameters: nk(n; k)";
		return 1;
	}
	else
	{
		var n=Re(pars[0]);
		var k=Re(pars[1]);
		if(k.toString().indexOf(".")>0)
		{
			errortext = "? k must be integer";
			return 1;
		}
		
		if(k==0)
			return v1;
		else if(k<0)
			return v0;		

		var alpha = pars[0];
		var i=0;
		var prod=divide(v1, fak(pars[1]));
		for(i=0; i<=(k-1); i++)
		{
			prod = multiply(prod, subtract(alpha, addValue(i, 0)));
		}
		
		return prod;
	}
}

function perm(st, pars)
{
	if(pars.length != 2)
	{
		errortext = "? Need 2 parameters: perm(n; k)";
		return 1;
	}
	else
	{
		var n=pars[0];
		var k=pars[1];
		if(Re(n)<Re(k))
		{
			errortext = "? perm error: n&lt;k";
			return 1;
		}
		
		if(Re(n)==0 && Im(n)==0)
			return v0;

		return divide(fak(n), fak(subtract(n, k)));
	}
}

function binomial(st, pars)
{
	if(pars.length != 3)
	{
		errortext = "? 3 parameters: binomial(n; k; p)";
		return 1;
	}
	else
	{
		var n=pars[0];
		var k=pars[1];
		var p=pars[2];
		
		var result = bincof(n, pars);
		result = multiply(result, cpow(p, k));
		result = multiply(result, cpow(subtract(v1, p), subtract(n, k)));
		return result;
	}
}


function modulo(st, pars)
{
	if(pars.length != 2)
	{
		errortext = "? 2 parameters: mod(a; b)";
		return 1;
	}
	else
	{
		var a=Re(pars[0]);
		var b=Re(pars[1]);
		
		if(b==0)
		{
			errortext = "? Modulo by zero: "+a+"%"+b;
			return 1;
		}	
		
		return addValue(a%b, 0);
	}
}

function trunc(st)
{
	return addValue(parseInt(Re(st)), parseInt(Im(st)));
}

function frac(st)
{
	return addValue(Re(st) - parseInt(Re(st)), Im(st) - parseInt(Im(st)));
}



function findMin(numbers)
{
	var i=0;
	var minimum = numbers[0];
	if(numbers.length > 1)
	{
		for(i=1; i<numbers.length; i++)
		{
			if(Re(numbers[i]) < Re(minimum))
				minimum = numbers[i];
		}
	}
	
	return minimum;
}

function findMax(numbers)
{
	var i=0;
	var maximum = numbers[0];
	if(numbers.length > 1)
	{
		for(i=1; i<numbers.length; i++)
		{
			if(Re(numbers[i]) > Re(maximum))
				maximum = numbers[i];
		}
	}
	
	return maximum;
}

function avg(numbers)
{
	var i=1;
	var sum = numbers[0];
	if(numbers.length > 1)
	{
		for(i=1; i<numbers.length; i++)
		{
			sum = add(sum, numbers[i]);
		}
	}
	
	return divide(sum, addValue(i, 0));
}


function fak(number)
{
	var res = 1;
	number = Re(number);
	var i=1;
	for(i=1; i<=number; i++)
	{
		res *= i;
	}
	return addValue(res, 0);
}

function makeAngle(st)
{
	if(!israd)
	{
		if(Im(st) == 0)
			st = addValue((Re(st)/180)*Math.PI, 0);
	}
	
	return st;
}

function execFunc(name, pars)
{
	efunc_counter++;
	if(efunc_counter > 50)
	{
		errortext = "? Infinite Loop";
		return v1;
	}
	
	
	var i = -1;
	for(i=0; i<funcs[0].length; i++)
	{
		if(funcs[0][i] == name)
			break;
	}
	
	if(funcs[2][i])
	{
		var params = funcs[2][i].split(";");
		if(params.length != pars.length)
		{
			errortext = "? "+params.length+" parameters required: "+name+"(";
			var j=0;
			for(j=0; j<params.length; j++)
			{
				if(j>0)
					errortext += "; ";
	
				errortext += params[j];
			}		
			errortext += ")";
			
			return v1;
		}
		else
		{
			var j=0;
			for(j=0; j<params.length; j++)
			{
				assignvar(params[j]+"="+resolveComplex_internally(pars[j]));
			}
		}
	}

	return solveProblemInternally(funcs[1][i]);
}

function HigherFunctions(mathstring)
{
	var i=0;
	
	var N_FUNCS = funcs[0].length;
	var N = N_HF + N_FUNCS;
	
	for(i=0; i<N; i++)
	{
		var fkt="";
		if(i < N_FUNCS)
			fkt = funcs[0][i];
		else
			fkt = hf[i - N_FUNCS];

		var l=0;
		if(fkt)
			l = fkt.length;
		else
			continue;
	
		var j=0;
		for(j=0; j<mathstring.length; j++)
		{
			var start = mathstring.indexOf(fkt, j);
			if(start > 0)
			{
				if(!isNoVar(mathstring.substr(start-1, 1)) || mathstring.substr(start-1, 1)=="e")
					continue;
			}
			if(start+l < mathstring.length)
			{
				if(!isNoVar(mathstring.substr(start+l, 1)) || mathstring.substr(start+l, 1)=="e")
					continue;
			}
			
			if(start >= 0)
			{
				var end = start+l;
				var rend = start+l;
				var rstart = start;
				if(mathstring.substr(rstart+l, 1) == "(")
				{
					end = FindOtherBracket(mathstring, start+l, 1, "(", ")");
					rend = end;
					rstart+=l+1;
					end++;
				}
				else
				{
					while((end < mathstring.length) &&
					  !isMop(mathstring.substr(end, 1)))
					end++;
					rstart+=l;
					rend = end;
				}
				
				var w = 0;
				var v = 1;
				var parsstring = mathstring.substr(rstart, rend-rstart);
				var splitarray = new Array;
				splitarray[0] = 0;
							
				for(w=0; w<parsstring.length; w++)
				{
					if(parsstring.substr(w, 1) == ";")
					{
						splitarray[v] = w+1;
						v++;
						w++;
					}
					else if(parsstring.substr(w, 1) == "(")
						w = FindOtherBracket(parsstring, w, 1, "(", ")");
				}
				splitarray[v] = parsstring.length;
				
				var pars = new Array;
				var u=0;
				for(u=0; u<splitarray.length-1; u++)
				{
					var subres = parsstring.substr(splitarray[u], splitarray[u+1]-splitarray[u]);
					if(subres.substr(subres.length-1, 1) == ";")
					{
						subres = subres.substr(0, subres.length-1);
					}
					
					pars[u] = solveProblemInternallyId(subres);
				}

				var st = pars[0];
			
				switch(i - N_FUNCS)
				{
				case(0): st = sqrt(st); break;
				case(1): st = ceil(st); break;
				case(2): st = floor(st); break;
				case(3): st = random(pars); break;
				case(4): st = round(st); break;
				case(5): st = abs(st); break;
				case(6): st = asinh(st); break;
				case(7): st = asinh(st); break;
				case(8): st = acosh(st); break;
				case(9): st = acosh(st); break;
				case(10):st = atanh(st); break;
				case(11):st = atanh(st); break;
				case(12):st = acoth(st); break;
				case(13):st = acoth(st); break;
				case(14):st = acosech(st); break;
				case(15):st = acosech(st); break;
				case(16):st = acosech(st); break;
				case(17):st = acosech(st); break;
				case(18):st = asech(st); break;
				case(19):st = asech(st); break;
				case(20): st = asinh(st); break;
				case(21): st = asinh(st); break;
				case(22): st = acosh(st); break;
				case(23): st = acosh(st); break;
				case(24):st = atanh(st); break;
				case(25):st = atanh(st); break;
				case(26):st = acoth(st); break;
				case(27):st = acoth(st); break;
				case(28):st = acosech(st); break;
				case(29):st = acosech(st); break;
				case(30):st = acosech(st); break;
				case(31):st = acosech(st); break;				
				case(32):st = asech(st); break;
				case(33):st = asech(st); break;
				case(34):st = sinh(st); break;
				case(35):st = sinh(st); break;
				case(36):st = cosh(st); break;
				case(37):st = cosh(st); break;
				case(38):st = tanh(st); break;
				case(39):st = tanh(st); break;
				case(40):st = coth(st); break;
				case(41):st = coth(st); break;
				case(42):st = cosech(st); break;
				case(43):st = cosech(st); break;
				case(44):st = cosech(st); break;
				case(45):st = cosech(st); break;
				case(46):st = sech(st); break;
				case(47):st = sech(st); break;
				case(48): st = atan(divide(v1, st)); break;
				case(49): st = atan(divide(v1, st)); break;
				case(50): st = asin(divide(v1, st)); break;
				case(51): st = asin(divide(v1, st)); break;
				case(52): st = asin(divide(v1, st)); break;
				case(53): st = asin(divide(v1, st)); break;				
				case(54): st = acos(divide(v1, st)); break;
				case(55): st = acos(divide(v1, st)); break;
				case(56): st = acos(st); break;
				case(57): st = acos(st); break;
				case(58): st = asin(st); break;
				case(59): st = asin(st); break;
				case(60): st = atan(st); break;
				case(61): st = atan(st); break;
				case(62): st = cot(makeAngle(st)); break;
				case(63): st = divide(v1, sin(makeAngle(st))); break;
				case(64): st = divide(v1, cos(makeAngle(st))); break;
				case(65): st = divide(v1, sin(makeAngle(st))); break;
				case(66): st = sin(makeAngle(st)); break;
				case(67): st = cos(makeAngle(st)); break;
				case(68): st = tan(makeAngle(st)); break;
				case(69): st = exp(st); break;
				case(70): st = ln(st); break;
				case(71): st = log(st, pars); break;
				case(72): st = log(st, new Array(st, addValue(10, 0))); break;
				case(73): st = log(st, new Array(st, v2)); break;
				case(74): st = sqrt(st); break;
				case(75): st = radpi(st); addPi=true; break;
				case(76): st = rad(st); break;
				case(77): st = deg(st); addDeg=true; break;
				case(78): st = arg(st); break;
				case(79): st = rt(st, pars); break;
				case(80): st = conj(st); break;
				case(81): st = lk(st, pars); break;
				case(82): st = gamma(st); break;
				case(83): st = gamma(st); break;
				case(84): st = delta(pars); break;
				case(85): st = delta(pars); break;
				case(86): st = levi(pars); break;
				case(87): st = sign(st); break;
				case(88): st = findMin(pars); break;
				case(89): st = findMax(pars); break;
				case(90): st = avg(pars); break;
				case(91): st = avg(pars); break;
				case(92): st = bincof(st, pars); break;
				case(93): st = bincof(st, pars); break;
				case(94): st = bincof(st, pars); break;
				case(95): st = perm(st, pars); break;
				case(96): st = perm(st, pars); break;
				case(97): st = binomial(st, pars); break;
				case(98): st = modulo(st, pars); break;
				case(99): st = modulo(st, pars); break;
				case(100): st = trunc(st); break;
				case(101): st = frac(st); break;
				case(102): st = heavi(st); break;
				case(103): st = heavi(st); break;
				default: st = execFunc(fkt, pars); break;
				}
				
				if(errortext == "")
				{
					if(st == "NaN") {errortext="? Error: "+hf[i]+mathstring.substr(start+l, end-start-l)+"=&infin;";}
					if(st == "-Infinity") {errortext="? neg. Infinity: "+hf[i]+mathstring.substr(start+l, end-start-l)+"=-&infin;";}	
					if(st == "Infinity") {errortext="? Infinity: "+hf[i]+mathstring.substr(start+l, end-start-l)+"=&infin;";}
				}
				mathstring = str_overwrite(start, end, mathstring, st);
			}
			else
				break;
		}	
	}

	return mathstring;
}

function PunktVorStrich(mathstring)
{
	var i=0;
	var j=0;
	var buffer = "";
	var startpos = 0;
	var stepper = 1;

	symbols = new Array("e", "^", "!", "/", "*");
	for(j=0; j<symbols.length; j++)
	{
		if(symbols[j] == "^")
		{
			startpos = mathstring.length-1;
			stepper = -1;
		}
		else
		{
			startpos = 0;
			stepper = 1;
		}
		
		for(i=startpos; i>=0 && i<mathstring.length; i+=stepper)
		{
			if(mathstring.substr(i, 1) == symbols[j])
			{
				var left = i-1;
				var right = i+1;
				
				while((left >= 0) &&
					  !isMop(mathstring.substr(left, 1)))
					left--;
			
				if(mathstring.substr(left, 1) == ")")
					left = FindOtherBracket(mathstring, left, -1, "(", ")");
	
				left++;
				var minusfirst = true;
				while((right < mathstring.length) &&
					  (mathstring.substr(right, 1) != "+") &&
					  ((mathstring.substr(right, 1) != "-") || minusfirst) &&
					  (mathstring.substr(right, 1) != "!") && 
					  (mathstring.substr(right, 1) != "*") && 
					  (mathstring.substr(right, 1) != "/") &&
					  (mathstring.substr(right, 1) != "^") &&
					  (mathstring.substr(right, 1) != ")") && 
					  (mathstring.substr(right, 1) != "(") &&
					  (mathstring.substr(right, 1) != "e"))
				{
					if(mathstring.substr(right, 1) != "-")
						minusfirst = false;
	
					right++;
				}
				
				if(symbols[j] != "!")
				{
					if(mathstring.substr(right, 1) == "(")
						right = FindOtherBracket(mathstring, right, 1, "(", ")");
					else if(right == (i+1))
					{
						right++;
						while((right < mathstring.length) &&
						  !isMop(mathstring.substr(right, 1)))
						right++;
					}
					
					right++; //compensate left
				}
				else
					right = i+2;
				
				mathstring = str_insert(left, "(", mathstring);
				mathstring = str_insert(right, ")", mathstring);
				
				i++;
			}
		}
	}
	return mathstring;
};

function parseVars(mathstring, prevstring)
{
	var i=0;
	for(i=vars[0].length-1; i>=0; i--)
	{
		var pos=mathstring.indexOf(vars[0][i]);
		while(pos >= 0)
		{
			if(isDigitOrPoint(mathstring.substr(pos-1, 1)) || isOp(mathstring.substr(pos-1, 1)) || isMop(mathstring.substr(pos-1, 1)) || pos==0)
			{
				var end=pos+vars[0][i].length;
					
				if(pos>0)
				{		
					if(isDigitOrPoint(mathstring.substr(pos-1, 1)) && mathstring.substr(pos-1, 1) != "*")
					{
						mathstring = str_insert(pos, "*", mathstring);
						pos++; end++;
					}
				}
				
				if(isDigitOrPoint(mathstring.substr(end, 1)) || isOp(mathstring.substr(end, 1)) || isMop(mathstring.substr(end, 1)) || end==mathstring.length)
					mathstring = str_overwrite(pos, end, mathstring, "("+str_replace(" ", "", double2string(vars[1][i]))+")");
			}
			
			pos=mathstring.indexOf(vars[0][i], pos+1);
		}
	}
	
	if(mathstring != prevstring)
		mathstring = parseVars(mathstring, mathstring);
	
	return mathstring;
}


function unequation(mathstring)
{
	var op = "";
	if(mathstring.indexOf("==") >= 0)
	{
		op="==";
		var sides = mathstring.split("==");
	}
	else if(mathstring.indexOf(">=") >= 0)
	{
		op=">=";
		var sides = mathstring.split(">=");
	}
	else if(mathstring.indexOf("<=") >= 0)
	{
		op="<=";
		var sides = mathstring.split("<=");
	}
	else if(mathstring.indexOf(">") >= 0)
	{
		op=">";
		var sides = mathstring.split(">");
	}
	else if(mathstring.indexOf("<") >= 0)
	{
		op="<";
		var sides = mathstring.split("<");	
	}
	
	if(sides.length != 2)
		return "? Error: too many.";
	
	var left=sides[0];
	var right=sides[1];
	
	var a = solveProblem(left)+" ";
	var b = solveProblem(right)+" ";	

	
	if(a.indexOf("*i") < 0 && b.indexOf("*i") < 0)
	{
		a = round_ms(a, r_digits);
		b = round_ms(b, r_digits);
		
		if(op == "==")
		{
			if(a == b)
				return "# true";
			else
				return "# false: " + a + " &ne; " + b;
		}
		else if(op == ">")
		{
			if(a > b)
				return "# true";
			else
				return "# false";
		}
		else if(op == "<")
		{
			if(a < b)
				return "# true";
			else
				return "# false";
		}
		else if(op == ">=")
		{
			if(a >= b)
				return "# true";
			else
				return "# false";
		}
		else if(op == "<=")
		{
			if(a <= b)
				return "# true";
			else
				return "# false";
		}
	}
	else
	{
		if(op == "==")
		{
			if(a == b)
				return "# true";
			else
				return "# false: " + a + " &ne; " + b;
		}
		else
			return "? Complex &rarr; Not comparable";	
	}
}

function assignvar(mathstring)
{
	mathstring = str_replace(" ", "", mathstring);
	mathstring = str_replace("&nbsp;", "", mathstring);
	mathstring = str_replace(spacerHex, "", mathstring);
	
	var sides = mathstring.split("=");
	
	if(sides.length != 2)
		return "? Error: too many.";
	
	var left = sides[0];
	var right = sides[1];
	
	var cv = checkVar(left);
	if(cv != 0)
	{
		errortext = "? Invalid character on left side: "+cv;
		return v1;
	}
	if(left == "e" || left == "i")
	{
		if(left == "e")
			errortext = "? Sorry, reserved for exponents";
		else if(left == "i")
			errortext = "? Sorry, reserved for imaginary unit";
		else
			errortext = "? Can&rsquo;t use " + left + " as a var name";
		return v1;		
	}
	
	if(!isDigitOrPoint(left.substr(0, 1)))
	{
		n=vars[0].length;
		
		var i=0;
		var n_funcs = funcs[0].length;
		for(i=0; i<n_funcs; i++)
		{
			if(funcs[0][i] == left)
			{
				funcs[0][i] = null;
				funcs[1][i] = null;
				saveFunc(i);
			}
		}
		
		var retOverwrite = false;
		for(i=0; i<n; i++)
		{
			if(vars[0][i] == left)
			{
				var solved = solveProblemInternally(right);
				vars[1][i] = resolveComplex_internally_dontRound(solved);
				saveVar(i);
				retOverwrite = true;
			}
		}
		if(retOverwrite)
			return "# Overwrite: " + left + "=" + resolveComplex(solved);
		
		var solved = solveProblemInternally(right);
		vars[0][n] = left;
		vars[1][n] = resolveComplex_internally_dontRound(solved);
		saveVar(n);
		
		return "# Assign: " + left + "=" + resolveComplex(solved);
	}
	else
	{
		return "? Did you mean "+left+"=="+right+"?";
	}
}

function assignfunction(mathstring)
{
	mathstring = str_replace(" ", "", mathstring);
	mathstring = str_replace("&nbsp;", "", mathstring);
	mathstring = str_replace(spacerHex, "", mathstring);
	var sides = mathstring.split(":");
	
	if(sides.length != 2)
		return "? Error: too many.";
	
	var left = sides[0];
	left = str_replace("*", "", left);
	var right = sides[1];
	
	var leftsides = left.split("(");
	left = leftsides[0];
	
	var cv = checkVar(left);
	if(cv != 0)
	{
		errortext = "? Invalid character on left side: "+cv;
		return v1;
	}
	else if(left == "" || left == undefined)
	{
		errortext = "? Invalid expression on left side";
		return v1;
	}
	
	var params = "";
	if(leftsides.length > 1)
	{
		if(leftsides[1].indexOf(")") > 0)
			params = leftsides[1].substr(0, leftsides[1].indexOf(")"));
		else
			params = leftsides[1];
	}
	
	if(!isDigitOrPoint(left.substr(0, 1)))
	{
		var rec = 0;
		var isrec = false;
		while(right.indexOf(left, rec) >= 0)
		{
			rec = right.indexOf(left, rec);
			if(rec >= 0)
			{
				if(rec == 0)
				{
					if(right.length == left.length)
					{
						return "? Recursive expression";
						break;
					}
					
					if(isNoVar(right.substr(rec+left.length, 1)))
					{
						return "? Recursive expression";
						break;
					}
				}
				
				if(isNoVar(right.substr(rec-1, 1)))
				{
					if(right.length-rec == left.length)
					{
						return "? Recursive expression";
						break;
					}
					
					if(isNoVar(right.substr(rec+left.length, 1)))
					{
						return "? Recursive expression";
						break;
					}
				}
			}
			
			rec++;
		}
		
		var i=0;
		var n_vars = vars[0].length;
		for(i=0; i<n_vars; i++)
		{
			if(vars[0][i] == left)
			{
				vars[0][i] = null;
				vars[1][i] = null;
				saveVar(i);
			}
		}

		var n=funcs[0].length;
		var retOverwrite = false;
		for(i=0; i<n; i++)
		{
			if(funcs[0][i] == left)
			{
				funcs[1][i] = Standardize(right, 1);
				funcs[2][i] = params;

				saveFunc(i);
				retOverwrite = true;
			}
		}
		
		funcs[0][n] = left;
		funcs[1][n] = Standardize(right, 1);
		funcs[2][n] = params;
		saveFunc(n);
		
		if(retOverwrite)
			return "# Overwrite: " + funcs[0][n] + "=" + funcs[1][n];
		
		return "# Assign: " + funcs[0][n] + "=" + funcs[1][n];
	}
	else
	{
		return "? Did you mean "+left+"=="+right+"?";
	}
}

function solve(mathstring, isneg)
{
	var b1 = mathstring.indexOf("(", 0);
	if(b1 >= 0)
	{
		var b2 = FindOtherBracket(mathstring, b1, 1, "(", ")");
		var l = b2 - b1;
		
		var res = solve(mathstring.substr(b1+1, l-1), false);

		mathstring = str_overwrite(b1, b2+1, mathstring, res);
		mathstring = EliminateDoubles(mathstring);
		mathstring = solve(mathstring, false);
	}
	else
	{
		var i=0;
		var buffer="";
		var s1 = 0;
		var s2 = 0;
		var op = 0;
		var prevop = 0;
		
		mathstring = EliminateDoubles(mathstring);
		
		for(i=0; i<mathstring.length; i++)
		{
			if(i>0)
			{
				if((mathstring.substr(i, 1) == "+") && !isSop(mathstring.substr(i-1, 1)))
					op = 1;
				else if((mathstring.substr(i, 1) == "-") && !isSop(mathstring.substr(i-1, 1)))
					op = 2;
				else if((mathstring.substr(i, 1) == "*") && !isSop(mathstring.substr(i-1, 1)))
					op = 3;
				else if((mathstring.substr(i, 1) == "/") && !isSop(mathstring.substr(i-1, 1)))
					op = 4;
				else if((mathstring.substr(i, 1) == "^") && !isSop(mathstring.substr(i-1, 1)))
					op = 5;
				else if((mathstring.substr(i, 1) == "!") && !isSop(mathstring.substr(i-1, 1)))
					buffer = double2string(fak(solve(buffer, false)));
				else
					buffer = buffer + mathstring.substr(i, 1);
			}
			else
				buffer = buffer + mathstring.substr(i, 1);

			if(i == (mathstring.length - 1))
				op = 99;
			
			if(op>0)
			{
				s1 = double2string(s2);
				if(buffer == "")
					s2 = 0;
				else
					s2 = buffer;
					
				var teststring = s1+"1"+s2;
				var start = 0;
				var end = 0;
				
				for(start=0; start<teststring.length; start++)
				{
					if(!isNoVar(teststring.substr(start, 1)))
					{
						end=start+1;
						while(end<teststring.length && !isNoVar(teststring.substr(end, 1)))
							end++;
							
						break;
					}
				}
				
				if(end != 0 && errortext == "")
				{
					if(teststring.substr(start, end-start) != "e" && teststring.substr(start, end-start) != "i" && teststring.substr(start, end-start) != "NaN")
					{
						errortext = "? Unknown: "+teststring.substr(start, end-start)+"=?";
						return 0;
					}
				}

				buffer="";
				switch(prevop)
				{
				case(1): s2=add(s1, s2); break;
				case(2): s2=subtract(s1, s2); break;
				case(3): s2=multiply(s1, s2); break;
				case(4): s2=divide(s1, s2); break;
				case(5): s2=cpow(s1, s2); break;
				}
				prevop = op;
				op = 0;
			}
		}

		mathstring = double2string(s2);
	}

	return mathstring;
};

function resolveComplex_internally_dontRound(i)
{
	var result = Re(i);

	if(Im(i) != 0)
	{
		if(Im(i) >= 0)
			result += " + "+ Im(i) + "*i";
		else
			result += " - "+ str_overwrite(0, 1, double2string(Im(i)), "") + "*i";
	}

	return result;
}

function resolveComplex_internally(i)
{
	var result = round_ms(round_ms(Re(i), ACC), r_digits);

	if(Im(i) != 0)
	{
		if(Im(i) >= 0)
			result += " + "+ round_ms(round_ms(Im(i), ACC), r_digits) + "*i";
		else
			result += " - "+ str_overwrite(0, 1, double2string(round_ms(round_ms(Im(i), ACC), r_digits)), "") + "*i";
	}

	return result;
}

function solveProblemInternally(mathstring)
{
	var std = Standardize(mathstring, 0);
	return solve(Standardize(PunktVorStrich(HigherFunctions(replaceNumbersById(parseVars(std, std)))), 1), false);
}

function solveProblemInternallyId(mathstring)
{
	var std = Standardize(mathstring, 0);
	return solve(Standardize(PunktVorStrich(HigherFunctions(parseVars(std, std))), 1), false);
}

function resolveComplex(mathstring)
{
	var result = resolveComplex_internally(mathstring);
	
	return result;
}

function solveProblem(mathstring)
{
	efunc_counter = 0;

	var result = solveProblemInternally(mathstring);
	var ansres = Re(result) + "+" + Im(result) + "*i";
	if(Im(result) == 0)
		result = double2string(resolveComplex(result));
	else
		result = resolveComplex(result);

	if((result!="") && (!doAssign))
	{
		if((result.indexOf("?") != 0) && (result.indexOf("#") != 0))
		{
			if(result.indexOf("NaN") < 0 && errortext == "")
			{
				vars[1][0] = ansres;
				vars[1][1] = ansres;
				vars[1][2] = ansres;
				vars[1][3] = ansres;
				addPi = false;
			}
		}
	}

	return result;
}

function round_ms(result, dg)
{
	if(Math.abs(result) > Math.pow(10, -dg+1) || (Math.abs(result) > Math.pow(10, -dg) && result > 1))
		var rounded = Math.round(result * Math.pow(10, dg)) / Math.pow(10, dg);
	else
		return result;
		
	if(rounded != 0)
		return rounded;
	else
		return result;
}